'
'     Classic Super Star Trek Game (QB64 source, https://qb64.com/ )
'
'     Trek32 is an enhanced and expanded recreation from memory of its function, of Super Star Trek written around
'     1975 in Fortran, I believe by David Matuszek & Paul Reynolds with modifications by Don Smith.
'
'     Copyright 2015 by Michael Burns US copyright registration number TXu002456119
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <https://www.gnu.org/licenses/>.
'
'    Converted from Quick Basic 4.5 to QB64 May 27 2015
'
DECLARE SUB PROLOG ()
DECLARE SUB TRANSPORT ()
DECLARE SUB SSCAN ()
DECLARE SUB ABANDON ()
DECLARE SUB CHNGCLOAK ()
DECLARE SUB COMMANDS ()
DECLARE SUB COMSCREEN ()
DECLARE SUB DELAY (X!)
DECLARE SUB DOCK ()
DECLARE SUB ENDGAME ()
DECLARE SUB GALDRAW ()
DECLARE SUB HELP ()
DECLARE SUB INITSECT ()
DECLARE SUB KATTACKS ()
DECLARE SUB LRSCAN ()
DECLARE SUB MAKEDISPLAY ()
DECLARE SUB MOVE ()
DECLARE SUB NOVA ()
DECLARE SUB PHASOR ()
DECLARE SUB PTORPEDOES ()
DECLARE SUB REPAIRS ()
DECLARE SUB REPAIRSTATUS ()
DECLARE SUB SECDRAW ()
DECLARE SUB SENERGY ()
DECLARE SUB SETWARP ()
DECLARE SUB SHIELD ()
DECLARE SUB SWAIT ()
DECLARE SUB SRANGESCAN ()
DECLARE SUB WORKSHEET ()
DECLARE SUB TIMEWARP ()
DIM GAL$(9, 9), HGAL$(9, 9), OGAL$(9, 9), CGAL(9, 9) ' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA, OGAL IS THE ORIGINAL
DIM SEC$(10, 10), SUPI(3), SUPJ(3), BEZI(5), BEZJ(5), BEZA(5)
DIM PLANI(10), PLANJ(10), PLANC(10), COMI(20), COMJ(20), ROMI(20), ROMJ(20)
DIM STRENGTH(9, 9), DLEN(8), BSI(5), BSJ(5)
COMMON SHARED GAL$(), HGAL$(), OGAL$(), CGAL(), LEVEL ' GAL$ IS FOR DISPLAY, HGAL$ IS THE DATA
COMMON SHARED SEC$(), SUPI(), SUPJ(), BEZI(), BEZJ(), BEZA()
COMMON SHARED PLANI(), PLANJ(), PLANC(), COMI(), COMJ(), ROMI(), ROMJ()
COMMON SHARED STRENGTH(), DLEN(), PLANETS, TDOWN, HEREWEARE
COMMON SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
COMMON SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, ODATE, life
COMMON SHARED TRANSPORTER, SX, SY, SHIP$, CLOAK, computer, EX, EY
COMMON SHARED BASES, HELPCOUNT



COMMON SHARED BERZERKS, Klingons, commanders, SUPERS, ENEMY, KLINGS
COMMON SHARED EATEN, ECLOAK, BFLAG, ROMULANS, oromulans
COMMON SHARED OKLINGONS, OCOMMANDERS, OSUPERS, OROLULANS, ENDOFGAME
COMMON SHARED KBERZERKERS, BASEDESTROYED, PLANETSLOST, IDATE
COMMON SHARED C$, BACKGROUND
COMMON SHARED BLUE, RED, GREEN, FRED, FBLUE, BLACK, PURPLE, ORANGE
COMMON SHARED DOCTOR$, ENGINEER$, WOFFICER$, COFFICER$, SOFFICER$, NAVIGATOR$, MENEMIES$, benemies$
VBEGIN: CLEAR
_TITLE "TREK32 by Michael Burns 2013"
VIEW PRINT 1 TO 25
RANDOMIZE TIMER:
SCREEN 0: CLS: WIDTH 80, 25
COLOR 7, 0: CLS
PRINT "Program TREK  V3.0 -- University of Florida, Physics"
PRINT "Written by BurnsLab (Where Science gets the business!)      FAX: (904) 392-0524"
PRINT "(Written by Michael Burns)"
PRINT "Uses math chip automatically if present."
PRINT "Original Version: 12-APR-1983"
PRINT "Translated to QuickBASOC: 18-JUL-1988"
PRINT "Last Update : 5-JAN-1991          CGA-EGA-VGA COLOR, MDA B&W VERSION"
PRINT "1991 version recompiled using QB64: 8-MAY-2013"
PRINT: PRINT
PRINT "Feel free to distribute copies of this program in unmodified form."
PRINT "There are no warrenties, implied or otherwise, that this program"
PRINT "will execute properly on any specific brand of machine. "
PRINT
PRINT "NOTE TO THOSE WHO HATE INSTRUCTIONS: The command syntax of this"
PRINT "version is close to the VAX versions of a decade ago. Except this"
PRINT "version is VERY intelligent and much more complicated."
PRINT
COLOR 12, 0: PRINT "Type ? <cr> during game for command list, hit F1 for help screen."
PRINT
PRINT
COLOR 7, 0
INITIALIZE: PRINT "Are you a beginner, intermediate or emeritus player (B, I, or E, <cr>=I) ";: INPUT A$
A$ = UCASE$(A$)
IF A$ = "" THEN A$ = "I"
IF A$ <> "B" AND A$ <> "I" AND A$ <> "E" THEN GOTO INITIALIZE
PRINT "Is this a color monitor (Y or N, <cr>=Y) ";: INPUT B$
B$ = UCASE$(B$)
IF LEFT$(B$, 1) = "N" THEN
    BACKGROUND = 0
    BLUE = 15
    RED = 15
    GREEN = 15
    FRED = 15 + 16
    FBLUE = 15 + 16
    BLACK = 7
    PURPLE = 15
    ORANGE = 15
ELSE
    BACKGROUND = 7
    BLUE = 1
    RED = 4
    GREEN = 2
    FRED = 20
    FBLUE = 17
    BLACK = 0
    PURPLE = 5
    ORANGE = 6
END IF
DOCTOR$ = "McKoy"
ENGINEER$ = "Scotty"
WOFFICER$ = "Chekov"
COFFICER$ = "Uhura"
SOFFICER$ = "Spock"
NAVIGATOR$ = "Sulu"
MENEMIES$ = "Klingon"
benemies$ = "Doomsday Machine"
PRINT "Is this Classic Trek "
PRINT "      or Next Generation Trek (C or N, <cr>= computer chooses) ";: INPUT B$
B$ = UCASE$(B$)
IF B$ = "" THEN
    IF RND > .5 THEN B$ = "C" ELSE B$ = "N"
END IF
IF LEFT$(B$, 1) = "N" THEN
    DOCTOR$ = "Dr. Crusher"
    ENGINEER$ = "Jory"
    WOFFICER$ = "Warf"
    COFFICER$ = "Warf"
    SOFFICER$ = "Data"
    NAVIGATOR$ = "Ensign Crusher"
    MENEMIES$ = "Ferengi"
    benemies$ = "Borg"
END IF
PRINT "Creating Galaxy. This may take a few seconds ..."
FOR I = 1 TO 9
    FOR J = 1 TO 9
        HGAL$(I, J) = ""
    NEXT J
NEXT I
IF A$ = "E" THEN
    LEVEL = 3
    Klingons = INT(30 * RND) + 85
    ROMULANS = INT(20 * RND)
    commanders = INT(20 * RND)
    SUPERS = INT(2 * RND) + 1
    BERZERKS = INT(5 * RND + 1)
    PLANETS = INT(10 * RND)
    BASES = INT(5 * RND) + 2
    SHIP$ = "U.S.S. ENTERPRISE"
    NOS = INT(30 * RND) + 40 ' NUMBER OF OCCUPIED SECTORS
END IF
IF A$ = "I" THEN
    LEVEL = 2
    Klingons = INT(30 * RND) + 50
    ROMULANS = INT(10 * RND)
    commanders = INT(5 * RND)
    SUPERS = 1
    BERZERKS = INT(3 * RND)
    PLANETS = INT(5 * RND)
    BASES = INT(3 * RND) + 2
    SHIP$ = "U.S.S. ENTERPRISE"
    NOS = INT(30 * RND) + 10 ' NUMBER OF OCCUPIED SECTORS
END IF
IF A$ = "B" THEN
    LEVEL = 1
    Klingons = INT(10 * RND) + 10
    ROMULANS = 0
    commanders = INT(2 * RND)
    SUPERS = 0
    BERZERKS = 0
    PLANETS = 2
    BASES = INT(3 * RND) + 2
    SHIP$ = "U.S.S. ENTERPRISE"
    NOS = INT(5 * RND) + 10 ' NUMBER OF OCCUPIED SECTORS
END IF
EATEN = 0
BASEDESTROYED = 0
PLANETSLOST = 0
OKLINGONS = Klingons
OSUPERS = SUPERS
oromulans = ROMULANS
OCOMMANDERS = commanders
OBERZERKERS = BERZERKS
GALAXY: KLINGONI = Klingons
FOR I = 1 TO 9
    FOR J = 1 TO 9
        NQUAD: ID = CINT(1 + RND * 8): JD = CINT(1 + RND * 8)
        IF ID < 1 OR ID > 9 OR JD < 1 OR JD > 9 THEN GOTO NQUAD
        IF HGAL$(ID, JD) <> "" THEN GOTO NQUAD
        S$ = LTRIM$(STR$(INT(7 * RND)))
        IF RND < .1 THEN S$ = "0"
        K = INT(7 * RND + 2)
        IF 1! - RND < .1 THEN K = 0
        IF K > KLINGONI THEN K = KLINGONI
        KLINGONI = KLINGONI - K
        KLINGI = KLINGI + K
        K$ = LTRIM$(STR$(K))
        HGAL$(ID, JD) = K$ + "0" + S$
        HGAL$(ID, JD) = LTRIM$(HGAL$(ID, JD))
        HGAL$(ID, JD) = RTRIM$(HGAL$(ID, JD))
        GAL$(ID, JD) = "---"
        OGAL$(ID, JD) = HGAL$(ID, JD)
NEXT J, I
IF commanders = 0 THEN GOTO SUPER
FOR I = 1 TO commanders
    COMI(I) = INT(8 * RND) + 1
    COMJ(I) = INT(8 * RND) + 1
NEXT I
SUPER: IF SUPERS = 0 THEN GOTO BERZERK
FOR I = 1 TO SUPERS
    SUPI(I) = INT(8 * RND) + 1
    SUPJ(I) = INT(8 * RND) + 1
NEXT I
BERZERK: IF BERZERKS = 0 THEN GOTO PLANET
FOR I = 1 TO BERZERKS
    BEZI(I) = INT(8 * RND) + 1
    BEZJ(I) = INT(8 * RND) + 1
    IF PLANETS < 10 THEN PLANETS = PLANETS + 1
    PLANI(I) = BEZI(I)
    PLANJ(I) = BEZJ(I)
    PLANC(I) = 0
    IF RND > .2 THEN PLANC(I) = 2 + INT(RND * 2)
    BEZA(I) = 0
NEXT I
PLANET: IF PLANETS = 0 THEN GOTO BASEL
FOR I = BERZERKS + 1 TO PLANETS
    PLANI(I) = INT(8 * RND) + 1
    PLANJ(I) = INT(8 * RND) + 1
    PLANC(I) = 0
    IF RND > .7 THEN PLANC(I) = 1 + INT(RND * 1)
NEXT I
BASEL: IF BASES = 0 THEN GOTO SHIP
FOR I = 1 TO BASES
    BASEAG: BASI = INT(8 * RND) + 1
    BASJ = INT(8 * RND) + 1
    IF INSTR(GAL$(BASI, BASJ), "B") <> 0 THEN GOTO BASEAG
    GAL$(BASI, BASJ) = "-B-"
    K$ = "": S$ = ""
    K$ = LEFT$(HGAL$(BASI, BASJ), 1)
    S$ = RIGHT$(HGAL$(BASI, BASJ), 1)
    HGAL$(BASI, BASJ) = K$ + "B" + S$
    OGAL$(BASI, BASJ) = HGAL$(BASI, BASJ)
NEXT I
SX = INT(8 * RND) + 1: SY = INT(8 * RND) + 1
SHIP: drive = 2
HELPCOUNT = 0
KLINGS = 0
CONDITION = 1
ENERGY = 20000
SHIELDS = 1
CLOAK = 1
SHENERGY = 10000
SPEED = 7
TDOWN = 0
HEREWEARE = 0
computer = 1
CRYSTALS = 1
PHASORS = 1
TORPEDOES = 20
SPERCENT = 100
life = 1
SDATE = INT(200 * RND) + 5000
FOR I = 1 TO 9
    FOR J = 1 TO 9
        CGAL(I, J) = SDATE
    NEXT J
NEXT I
IDATE = SDATE
TRANSPORTER = 1
GAL$(SX, SY) = RIGHT$(HGAL$(SX, SY), 3)
EX = INT(8 * RND) + 1: EY = INT(8 * RND) + 1
CALL INITSECT
CALL PROLOG
SCREEN 0: COLOR BLUE, BACKGROUND, 7: CLS
LOCATE 21, 1
CALL MAKEDISPLAY
ON KEY(1) GOSUB COMDISPLAY
KEY(1) ON
IF LEVEL = 1 THEN ON TIMER(20) GOSUB ATTACKS
IF LEVEL = 2 THEN ON TIMER(10) GOSUB ATTACKS
IF LEVEL = 3 THEN ON TIMER(5) GOSUB ATTACKS
TIMER ON
'ON ERROR GOTO ERRMESSAGE
ON ERROR GOTO 0
GETCOM: COLOR BLUE, BACKGROUND: TIMER ON
'X = FRE(0)
IF Klingons < 1 THEN CALL ENDGAME
'X = FRE("")
COLOR RED, BACKGROUND
X = POS(0)
Y = CSRLIN
LOCATE 25, 1
PRINT "Press ? <Enter> for command list, Press F1 for help";
LOCATE Y, X
COLOR BLUE, BACKGROUND
PRINT "Command ? ";
WCOM: A$ = INKEY$: IF A$ = "" THEN GOTO WCOM
IF A$ = CHR$(14) THEN CLS: GOTO GETCOM
COLOR BLACK, BACKGROUND
PRINT A$;
LINE INPUT ""; C$
C$ = A$ + C$
CLS
IF MENEMIES$ <> "Klingon" THEN
    IF RND > .5 THEN
        COFFICER$ = "Riker"
        WOFFICER$ = "Riker"
    ELSE
        COFFICER$ = "Warf"
        WOFFICER$ = "Warf"
    END IF
END IF
ENDOFGAME = 0
ODATE = SDATE
CGAL(SX, SY) = SDATE
C$ = UCASE$(C$)
C$ = LTRIM$(C$): C$ = RTRIM$(C$)
IF C$ = "ABANDON" THEN CALL ABANDON: GOTO GETCOM
IF LEFT$(C$, 2) = "CL" THEN CALL CHNGCLOAK: CALL KATTACKS: GOTO UNIVRESPONSE
IF C$ = "D" OR C$ = "DOCK" THEN CALL DOCK: GOTO UNIVRESPONSE
IF C$ = "?" THEN CALL COMMANDS: GOTO UNIVRESPONSE
IF LEFT$(C$, 4) = "HELP" THEN CALL HELP: GOTO UNIVRESPONSE
IF C$ = "L" OR C$ = "LONG" THEN CALL LRSCAN: GOTO UNIVRESPONSE
IF LEFT$(C$, 2) = "M " THEN CALL MOVE: CALL KATTACKS: GOTO UNIVRESPONSE
IF LEFT$(C$, 2) = "T " THEN CALL PTORPEDOES: CALL KATTACKS: GOTO UNIVRESPONSE
IF LEFT$(C$, 2) = "TR" THEN CALL TRANSPORT: GOTO UNIVRESPONSE
IF LEFT$(C$, 1) = "P" THEN CALL PHASOR: CALL KATTACKS: GOTO UNIVRESPONSE
IF LEFT$(C$, 2) = "SE" THEN CALL SENERGY: CALL KATTACKS: GOTO UNIVRESPONSE
IF LEFT$(C$, 2) = "SH" THEN CALL SHIELD: CALL KATTACKS: GOTO UNIVRESPONSE
IF LEFT$(C$, 2) = "WA" THEN CALL SWAIT: CALL REPAIRS: CALL KATTACKS: GOTO GETCOM
IF LEFT$(C$, 1) = "W" THEN CALL SETWARP: GOTO UNIVRESPONSE
IF LEFT$(C$, 2) = "RS" THEN CALL REPAIRSTATUS
IF LEFT$(C$, 1) = "F" THEN CALL WORKSHEET
IF C$ = "S" THEN
    CALL SSCAN
    VIEW PRINT 1 TO 24
    CLS
    CALL MAKEDISPLAY
END IF
IF C$ = "QUIT" THEN CALL ENDGAME
UNIVRESPONSE: IF ENDOFGAME = 1 THEN
    VIEW PRINT 1 TO 24
    CLS
    GOTO VBEGIN
END IF
CALL REPAIRS
GOTO GETCOM
ERRMESSAGE: COLOR RED, BACKGROUND: PRINT "Say what, Captain ?": COLOR BLUE, BACKGROUND
PRINT: PRINT
RESUME GETCOM
COMDISPLAY: CALL COMSCREEN
CLS
COLOR RED, BACKGROUND
X = POS(0)
Y = CSRLIN
LOCATE 25, 1
PRINT "Press ? <Enter> for command list, Press F1 for help    ";
LOCATE Y, X
COLOR BLUE, BACKGROUND
PRINT "Command ? ";
RETURN
ATTACKS: TIMER OFF
cursorcol = POS(0): cursorrow = CSRLIN
BFLAG = 0
KATT = KATT + 1
FOR XXB = 1 TO BERZERKS
    IF BEZA(XXB) = 1 THEN BFLAG = BFLAG + 1
NEXT XXB
BFLG = BFLAG
FOR BBI = 1 TO 9
    FOR BBJ = 1 TO 9
        IF SEC$(BBI, BBJ) = CHR$(21) AND BFLAG > 0 THEN
            BSI(BFLG) = BBI: BSJ(BFLG) = BBJ
            BFLG = BFLG - 1
        END IF
    NEXT BBJ
NEXT BBI
EGAME = 0
FOR XXB = 1 TO BFLAG
    INDEX = -1: IF BSI(XXB) < EX THEN INDEX = 1
    INDEY = -1: IF BSJ(XXB) < EY THEN INDEY = 1
    IF BSI(XXB) = EX THEN INDEX = 0
    IF BSI(XXB) = EY THEN INDEY = 0
    OX = BSI(XXB): OY = BSJ(XXB)
    BSI(XXB) = BSI(XXB) + INDEX
    BSJ(XXB) = BSJ(XXB) + INDEY
    IF BSI(XXB) < 1 THEN BSI(XXB) = 1
    IF BSI(XXB) > 9 THEN BSI(XXB) = 9
    IF BSJ(XXB) < 1 THEN BSJ(XXB) = 1
    IF BSJ(XXB) > 9 THEN BSJ(XXB) = 9
    SEC$(OX, OY) = "."
    IF SEC$(BSI(XXB), BSJ(XXB)) = "E" THEN EATEN = 1: CALL ENDGAME
    IF SEC$(BSI(XXB), BSJ(XXB)) = "Q" THEN EATEN = 1: CALL ENDGAME
    IF SEC$(BSI(XXB), BSJ(XXB)) = "S" OR SEC$(BSI(XXB), BSJ(XXB)) = "C" OR SEC$(BSI(XXB), BSJ(XXB)) = "K" THEN
        Klingons = Klingons - 1: KLINGS = KLINGS - 1
        ENEMY = ENEMY - 1
        STRENGTH(BSI(XXB), BSJ(XXB)) = 0
    END IF
    IF SEC$(BSI(XXB), BSJ(XXB)) = "S" THEN
        SUPERS = SUPERS - 1
        FOR SI = 1 TO 3
            IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
        NEXT SI
    END IF
    IF SEC$(BSI(XXB), BSJ(XXB)) = "C" THEN
        commanders = commanders - 1
        FOR SI = 1 TO 20
            IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
        NEXT SI
    END IF
    IF SEC$(BSI(XXB), BSJ(XXB)) = " " THEN
        KBERZERKERS = KBERZERKERS + 1
        FOR XXBB = 1 TO BERZERKS
            IF BEZA(XXBB) = 1 THEN
                BEZA(XXBB) = 0
                GOTO OUTBERZERKS
            END IF
        NEXT XXBB
        OUTBERZERKS: SEC$(BSI(XXB), BSJ(XXB)) = " "
        COLOR RED, BACKGROUND
        PRINT SOFFICER$; " reports, '"; benemies$; " just fell down a Black Hole, Captain.'"
        COLOR BLUE, BACKGROUND
        GOTO STARTKS
    END IF
    SEC$(BSI(XXB), BSJ(XXB)) = CHR$(21)
NEXT XXB
STARTKS: IF KATT = 2 + INT(RND * 2) THEN KATT = 0: CALL KATTACKS
FOR IIJ = 1 TO 3
    IF SUPI(IIJ) = SX AND SUPJ(IIJ) = SY THEN GOTO EATTACKS
NEXT IIJ
IF LEVEL > 1 AND ENERGY < 3000 AND CONDITION >= 0 THEN
    FOR IIJ = 1 TO 3
        IF SUPI(IIJ) <> 0 AND SUPJ(IIJ) <> 0 THEN
            PRINT SHIP$; " pulled to quadrant "; SUPI(IIJ); ","; SUPJ(IIJ); " by long range tractor beam."
            SX = SUPI(IIJ): SY = SUPJ(IIJ)
            PRINT "Command ?";
            cursorcol = POS(0): cursorrow = CSRLIN
            CALL INITSECT
            CALL MAKEDISPLAY
            FOR JJI = 1 TO 4000: NEXT JJI
            GOTO EATTACKS
        END IF
    NEXT IIJ
END IF
IF RND * LEVEL > 1 AND SHIELDS < 0 AND CONDITION >= 0 THEN
    FOR IIJ = 1 TO 3
        IF SUPI(IIJ) <> 0 AND SUPJ(IIJ) <> 0 THEN
            PRINT SHIP$; " pulled to quadrant "; SUPI(IIJ); ","; SUPJ(IIJ); " by long range tractor beam."
            SX = SUPI(IIJ): SY = SUPJ(IIJ)
            PRINT "Command ?";
            cursorcol = POS(0): cursorrow = CSRLIN
            CALL INITSECT
            CALL MAKEDISPLAY
            FOR JJI = 1 TO 4000: NEXT JJI
            GOTO EATTACKS
        END IF
    NEXT IIJ
END IF
CALL SECDRAW
EATTACKS: RDUMMY = RND
IF RDUMMY < .48 OR RDUMMY > .5 OR LEVEL = 1 THEN
    LOCATE cursorrow, cursorcol
    RETURN
END IF
IF BASES = 0 THEN
    LOCATE cursorrow, cursorcol
    RETURN
END IF
BASEINSERT: FOR KI = 1 TO 9
    FOR KJ = 1 TO 9
        X = 0
        X = INSTR(GAL$(KI, KJ), "B")
        IF KI = SX AND KJ = SY THEN X = 0
        IF SUPERS <= 0 THEN X = 0
        IF X <> 0 THEN
            BASES = BASES - 1
            HGAL$(KI, KJ) = LTRIM$(HGAL$(KI, KJ))
            HGAL$(KI, KJ) = RTRIM$(HGAL$(KI, KJ))
            KK$ = LEFT$(HGAL$(KI, KJ), 1)
            KS$ = RIGHT$(HGAL$(KI, KJ), 1)
            HGAL$(KI, KJ) = ""
            HGAL$(KI, KJ) = KK$ + "0" + KS$
            GAL$(KI, KJ) = HGAL$(KI, KJ)
            CGAL(KI, KJ) = NDATE
            GOTO DBASE
        END IF
    NEXT KJ
NEXT KI
COLOR RED, BACKGROUND
X = POS(0)
Y = CSRLIN
LOCATE 25, 1
PRINT "Press ? <Enter> for command list, Press F1 for help    ";
LOCATE Y, X
COLOR BLUE, BACKGROUND
PRINT "Command ? ";
TIMER ON
RETURN
DBASE: CALL MAKEDISPLAY
COLOR RED, BACKGROUND
PRINT COFFICER$; " reports, 'StarFeet reports StarBase "; INT(1 + RND * 20); "in quadrant "; KI; ","; KJ; " is DESTROYED !'"
COLOR RED, BACKGROUND
X = POS(0)
Y = CSRLIN
LOCATE 25, 1
PRINT "Press ? <Enter> for command list, Press F1 for help    ";
LOCATE Y, X
COLOR BLUE, BACKGROUND
PRINT "Command ? ";
TIMER ON
RETURN

SUB COMMANDS
'
' Here we display the possible commands
'
SHARED BACKGROUND
TEMP = BLUE
IF BACKGROUND = 0 THEN BLUE = 7
COLOR RED, BACKGROUND
PRINT "Commands: RED ";: COLOR BLUE, BACKGROUND: PRINT "letters ONLY. F1 <ENTER> FOR DETAILED HELP."
COLOR RED, BACKGROUND
PRINT "ABANDON       ";
COLOR RED, BACKGROUND: PRINT "CL";: COLOR BLUE, BACKGROUND: PRINT "oak  ";
COLOR RED, BACKGROUND: PRINT "D";: COLOR BLUE, BACKGROUND: PRINT "ock  ";
COLOR RED, BACKGROUND: PRINT "L";: COLOR BLUE, BACKGROUND: PRINT "ong Range Scan      ";
COLOR RED, BACKGROUND: PRINT "M";: COLOR BLUE, BACKGROUND: PRINT "ove    ";
COLOR RED, BACKGROUND: PRINT "P";: COLOR BLUE, BACKGROUND: PRINT "hasors         "
COLOR RED, BACKGROUND: PRINT "QUIT ";: COLOR BLUE, BACKGROUND
COLOR RED, BACKGROUND: PRINT " RS";: COLOR BLUE, BACKGROUND: PRINT " Repair Status  ";
COLOR RED, BACKGROUND: PRINT "S";: COLOR BLUE, BACKGROUND: PRINT "hort Range Scan   ";
COLOR RED, BACKGROUND: PRINT "SE";: COLOR BLUE, BACKGROUND: PRINT " Shield Energy     ";
COLOR RED, BACKGROUND: PRINT "SH";: COLOR BLUE, BACKGROUND: PRINT "ields"
COLOR RED, BACKGROUND: PRINT "T";: COLOR BLUE, BACKGROUND: PRINT "orpedoes    ";
COLOR RED, BACKGROUND: PRINT "TR";: COLOR BLUE, BACKGROUND: PRINT "ransporter ";
COLOR RED, BACKGROUND: PRINT "W";: COLOR BLUE, BACKGROUND: PRINT "arp  ";
COLOR RED, BACKGROUND: PRINT "WA";: COLOR BLUE, BACKGROUND: PRINT "it  ";
COLOR RED, BACKGROUND: PRINT "F";: COLOR BLUE, BACKGROUND: PRINT "lips to fake work sheet"
BLUE = TEMP
END SUB

SUB MOVE
'
' Here we move the ship
'
SHARED SX, SY, SHIP$, EX, EY
SHARED ROMULANS, commanders, SUPERS, BERZERKS, PLANETS, BASES
SHARED KLINGS, TDOWN
SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
SHARED TRANSPORTER, C$, computer, IDATE, BACKGROUND
DIM CORD(4)
IF TDOWN = 1 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'Abandoning the landing party is a capital offense, Captian.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
TNSX = 0: TNSY = 0
IF CLOAK = 1 THEN ECLOAK = 1
IF CRYSTALS = 0 AND SPEED > 1 THEN
    COLOR RED, BACKGROUND
    PRINT SOFFICER$; " says, 'Captain, running the warp drive with bad crystals can destroy the ship."
    PRINT "Should we proceed ?'";: COLOR BLACK, BACKGROUND: INPUT Y$
    Y$ = UCASE$(Y$)
    IF LEFT$(Y$, 1) = "Y" THEN GOTO MSTART
    EXIT SUB
END IF
MSTART: I = LEN(C$) - 2: AUTO = 0: MAUTO = 1
IF CRYSTALS = 0 AND RND > .9 AND SPEED > 1 THEN
    CALL TIMEWARP
    EXIT SUB
END IF
IF SPEED * SPEED > 60 + RND * 36 THEN
    CALL TIMEWARP
    SPEED = 1
    ENERGY = 500
    CALL MAKEDISPLAY
    PRINT SOFFICER$; " reports, 'The antimatter reactor seems to be drained.'"
    EXIT SUB
END IF
C$ = RIGHT$(C$, I)
J = INSTR(C$, "M")
IF J = 0 THEN AUTO = 1: J = INSTR(C$, "A")
IF AUTO = 1 AND computer = 0 THEN
    CLS
    COLOR RED, BACKGROUND
    PRINT WOFFICER$; " reports, 'We cannot navigate automatically with a damaged computer, Captain.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF J = 0 THEN COLOR RED, BACKGROUND: PRINT "Wrong syntax": COLOR BLUE, BACKGROUND: EXIT SUB
I = LEN(C$)
C$ = LTRIM$(RIGHT$(C$, I - J))
I = LEN(C$)
IF AUTO = 0 THEN GOTO MANUAL
IF AUTO = 1 AND INSTR(C$, "-") <> 0 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " says, 'Huh ?'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF I = 3 THEN
    NSX = VAL(LEFT$(C$, 1))
    NSY = VAL(RIGHT$(C$, 1))
    NGAX = 0: NGAY = 0
    TNSX = 0: TNSY = 0
ELSE
    NGAX = VAL(LEFT$(C$, 1))
    NGAY = VAL(MID$(C$, 3, 1))
    TNSX = VAL(MID$(C$, 5, 1))
    TNSY = VAL(RIGHT$(C$, 1))
    IX = NGAX - SX: IY = NGAY - SY
    IF IX <> 0 THEN
        SLOPE = IY / IX
        IF IX < 0 THEN NSX = 1 ELSE NSX = 9
        MLOOP: NSY = SLOPE * (NSX - EX) + EY
        IF NSY < 1 OR NSY > 9 THEN NSX = NSX - SGN(IX): GOTO MLOOP
        GOTO MENTRY
    END IF
    IF IX = 0 THEN NSX = EX: NSY = 9 * IY
    IF NSX > 9 THEN NSX = 9
    IF NSX < 1 THEN NSX = 1
    IF NSY > 9 THEN NSY = 9
    IF NSY < 1 THEN NSY = 1
END IF
MENTRY: GDIST = SQR((SX - NGAX) ^ 2 + (SY - NGAY) ^ 2)
ELOSS = (SPEED ^ 3) * GDIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
IF ELOSS > ENERGY THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " says, 'But Captain, we need a wee bit more energy to do that !'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IX = NSX - EX: IY = NSY - EY
IF IX <> 0 THEN SLOPE = IY / IX
INDEX = 1: IF NSX < EX THEN INDEX = -1
INDEY = 1: IF NSY < EY THEN INDEY = -1
TRAJECTORY = EY
FOR J = EX TO NSX STEP INDEX
    IF J < 1 THEN GOTO ENDJ
    IF IX <> 0 THEN TRAJECTORY = CINT((SLOPE * (J - EX)) + EY)
    IF IX = 0 THEN TRAJECTORY = TRAJECTORY + INDEY
    IF TRAJECTORY < 1 OR TRAJECTORY > 9 THEN GOTO ENDJ
    IF SEC$(J, TRAJECTORY) <> "." AND SEC$(J, TRAJECTORY) <> "E" AND SEC$(J, TRAJECTORY) <> "Q" THEN GOTO COLLISION
ENDJ: NEXT J
IF NGAX = 0 THEN
    IF SEC$(NSX, NSY) <> "." AND SEC$(NSX, NSY) <> "E" AND SEC$(NSX, NSY) <> "Q" THEN GOTO COLLISION
    DIST = SQR((EX - NSX) ^ 2 + (EY - NSY) ^ 2) / 10
    ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
    ENERGY = ENERGY - ELOSS
    IF ENERGY < 0 THEN ENERGY = 0
    SDATE = SDATE + GDIST / (SPEED * SPEED)
    IF NSX < 1 THEN NSX = 1
    IF NSY < 1 THEN NSY = 1
    SEC$(EX, EY) = "."
    EX = NSX: EY = NSY
    IF KLINGS <> 0 THEN CONDITION = 3
    IF CONDITION < 1 THEN CONDITION = 1
    CALL MAKEDISPLAY
    EXIT SUB
END IF
SEC$(EX, EY) = "."
DIST = SQR((EX - J) ^ 2 + (EY - TRAJECTORY) ^ 2) / 10
IF TNSX = 0 THEN
    EX = NSX
    EY = NSY
ELSE
    EX = TNSX
    EY = TNSY
END IF
GDIST = DIST + SQR((SX - NGAX) ^ 2 + (SY - NGAY) ^ 2)
SX = NGAX
SY = NGAY
IF CONDITION < 1 THEN CONDITION = 1
CALL INITSECT
ELOSS = (SPEED ^ 3) * GDIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
ENERGY = ENERGY - ELOSS
IF ENERGY < 0 THEN ENERGY = 0
SDATE = SDATE + GDIST / (SPEED * SPEED)
IF KLINGS <> 0 THEN CONDITION = 3
CALL MAKEDISPLAY
EXIT SUB
MANUAL: AUTO = 1: MAUTO = 0
CCOUNT = 0
FOR PARSE = 1 TO 4
    CORD(PARSE) = 0
    C$ = LTRIM$(C$): C$ = RTRIM$(C$)
    IF C$ = "" THEN GOTO NPARSE
    I = LEN(C$)
    IF INSTR(C$, " ") <> 0 AND I <> 0 THEN
        CORD(PARSE) = VAL(LEFT$(C$, INSTR(C$, " ")))
        C$ = RIGHT$(C$, I - INSTR(C$, " "))
        CCOUNT = CCOUNT + 1
        GOTO NPARSE
    END IF
    IF INSTR(C$, " ") = 0 AND I <> 0 THEN CORD(PARSE) = VAL(C$): CCOUNT = CCOUNT + 1: C$ = ""
NPARSE: NEXT PARSE
STMAN: BARFLAG = 0
IF CCOUNT > 2 THEN
    BARFLAG = 1
    NGAX = CORD(1) + SX
    NGAY = CORD(2) + SY
    NSX = CORD(3) + EX
    NSY = CORD(4) + EY
    NGAX = INT((NGAX * 10 + NSX) / 10): NGAY = INT((NGAY * 10 + NSY) / 10)
    NSX = (NSX MOD 10) + 1: NSY = (NSY MOD 10) + 1
    TNSX = NSX: TNSY = NSY
ELSE
    NSX = CORD(1) + EX
    NSY = CORD(2) + EY
    TNSX = 0: TNSY = 0
    NGAX = INT((NGAX * 10 + NSX) / 10): NGAY = INT((NGAY * 10 + NSY) / 10)
    IF NGAX <> 0 OR NGAY <> 0 THEN
        NGAX = NGAX + SX: NGAY = NGAY + SY
        BARFLAG = 1
        NSX = (NSX MOD 10) + 1: NSY = (NSY MOD 10) + 1
        TNSX = NSX: TNSY = NSY
    END IF
END IF
IF NSX < 1 THEN NSX = NSX + 10: TNSX = NSX: TNSY = NSY: BARFLAG = 1
IF NSY < 1 THEN NSY = NSY + 10: TNSX = NSX: TNSY = NSY: BARFLAG = 1
IF NGAX > 9 AND BARFLAG = 1 THEN NGAX = 9: GOSUB BARRIER: GOTO MENTRY
IF NGAX < 1 AND BARFLAG = 1 THEN NGAX = 1: GOSUB BARRIER: GOTO MENTRY
IF NGAY > 9 AND BARFLAG = 1 THEN NGAY = 9: GOSUB BARRIER: GOTO MENTRY
IF NGAY < 1 AND BARFLAG = 1 THEN NGAY = 1: GOSUB BARRIER: GOTO MENTRY
GOTO MENTRY
COLLISION: IF computer = 0 OR MAUTO = 0 THEN GOTO MCOLLISION
JJ = -1 * INDEX + J
TRAJECTORYJ = TRAJECTORY
IF IX <> 0 THEN TRAJECTORYJ = CINT((SLOPE * (JJ - EX)) + EY)
IF IX = 0 THEN TRAJECTORYJ = TRAJECTORYJ - INDEY
DIST = SQR((EX - JJ) ^ 2 + (EY - TRAJECTORYJ) ^ 2) / 10
ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
ENERGY = ENERGY - ELOSS
IF ENERGY < 0 THEN ENERGY = 0
SDATE = SDATE + DIST / (SPEED * SPEED)
SEC$(EX, EY) = "."
EX = JJ: EY = TRAJECTORYJ
IF KLINGS <> 0 THEN CONDITION = 3
CALL MAKEDISPLAY
COLOR RED, BACKGROUND
PRINT NAVIGATOR$; " exclaims, ' Emergency stop activated, Captain !'"
PRINT "We were about to collide with the ";
IF SEC$(J, TRAJECTORY) = " " THEN PRINT "Black Hole ";
IF SEC$(J, TRAJECTORY) = "K" THEN PRINT MENEMIES$;
IF SEC$(J, TRAJECTORY) = "C" THEN PRINT MENEMIES$; " Commander ";
IF SEC$(J, TRAJECTORY) = "P" THEN PRINT "planet ";
IF SEC$(J, TRAJECTORY) = "S" THEN PRINT MENEMIES$; "Super Commander ";
IF SEC$(J, TRAJECTORY) = CHR$(21) THEN PRINT benemies$; " ";
IF SEC$(J, TRAJECTORY) = CHR$(15) THEN PRINT "star ";
IF SEC$(J, TRAJECTORY) = "B" THEN PRINT "Star Base  ";
IF SEC$(J, TRAJECTORY) = "R" THEN PRINT "Romulan ";
PRINT "at "; STR$(J); ","; STR$(TRAJECTORY); "."
COLOR BLUE, BACKGROUND
EXIT SUB
MCOLLISION: COLOR RED, BACKGROUND: BEEP
PRINT NAVIGATOR$; " screams, 'We're all going to die ! Collision !'"
COLOR BLUE, BACKGROUND
PRINT SHIP$; " collides with ";
IF SEC$(J, TRAJECTORY) = " " THEN PRINT "Black Hole ";
IF SEC$(J, TRAJECTORY) = "K" THEN PRINT MENEMIES$;
IF SEC$(J, TRAJECTORY) = "C" THEN PRINT MENEMIES$; " Commander ";
IF SEC$(J, TRAJECTORY) = "P" THEN PRINT "planet ";
IF SEC$(J, TRAJECTORY) = "S" THEN PRINT MENEMIES$; "Super Commander ";
IF SEC$(J, TRAJECTORY) = CHR$(21) THEN PRINT benemies$; " ";
IF SEC$(J, TRAJECTORY) = CHR$(15) THEN PRINT "star ";
IF SEC$(J, TRAJECTORY) = "B" THEN PRINT "Star Base  ";
IF SEC$(J, TRAJECTORY) = "R" THEN PRINT "Romulan ";
PRINT "at "; STR$(J); ","; STR$(TRAJECTORY); "."
CALL DELAY(3)
IF SEC$(J, TRAJECTORY) = " " THEN
    PRINT "The "; SHIP$; " was sucked down a Black Hole."
    IF RND > .2 THEN CALL ENDGAME: EXIT SUB
    CALL TIMEWARP
    EXIT SUB
END IF
IF RND * SPEED > 6 THEN CALL ENDGAME: EXIT SUB
SEC$(EX, EY) = "."
NLOC: EX = INT(8 * RND + 1): EY = INT(RND * 8 + 1)
IF SEC$(EX, EY) <> "." THEN GOTO NLOC
DIST = SQR((EX - JJ) ^ 2 + (EY - TRAJECTORYJ) ^ 2) / 10
ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
ENERGY = ENERGY - ELOSS
IF ENERGY < 0 THEN ENERGY = 0
SDATE = SDATE + DIST / (SPEED * SPEED)
PRINT SHIP$; " thrown by force of collision to "; EX; ","; EY; "."
IF 2 * RND * SPEED > SPEED * SHIELDS THEN
    PRINT "Computer Damaged ";
    DLEN(6) = RND * SPEED
    computer = 0
END IF
IF 2 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
    PRINT "All Weapons Damaged ";
    TORPEDOES = -1 * ABS(TORPEDOES)
    PHASORS = 0
    DLEN(4) = RND * SPEED
    DLEN(3) = DLEN(4) * RND
END IF
IF 2 * RND * SPEED > SPEED * (.5 + SHIELDS) THEN
    PRINT "Shields Damaged ";
    DLEN(2) = RND * SPEED
    SHIELDS = -1 * ABS(SHIELDS)
END IF
IF .5 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
    PRINT "Life support damaged ";
    life = 0
    DLEN(7) = RND * SPEED
END IF
IF .1 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
    PRINT "Crystals deterioriating ";
    CRYSTALS = 0
    DLEN(8) = 20 * (1 - RND) / SPEED
END IF
IF KLINGS <> 0 THEN CONDITION = 3
PRINT
CALL MAKEDISPLAY
EXIT SUB
BARRIER: COLOR RED, BACKGROUND
BEEP
PRINT NAVIGATOR$; " exclaims, 'We have collided with the Energy Barrier which"
PRINT "surrounds the Galaxy. Emergency stop executed.'"
COLOR RED, BACKGROUND
RETURN
END SUB

SUB PHASOR
'
'  This routine does the phaser fire control
'
SHARED SX, SY, SHIP$, EX, EY
SHARED ROMULANS, commanders, SUPERS, BERZERKS, PLANETS, BASES
SHARED KLINGS, ENEMY, Klingons
SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
SHARED TRANSPORTER, C$, computer, BACKGROUND
SHARED STRENGTH(), SEC$()
DIM THREATX(15), THREATY(15), THREATP(15), KEN(15), PFIRE(15)
SCPEN = 0
IF SHIELDS = 1 THEN SCPEN = SCPEN + .5
IF CLOAK = 1 THEN SCPEN = SCPEN + .5
IF PHASORS <> 1 THEN
    COLOR RED, BACKGROUND
    PRINT "Fire Control reporting, Sir. The Phasor generators won't fire."
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
I = LEN(C$) - 2: AUTO = 0: MAUTO = 1
C$ = RIGHT$(C$, I)
J = INSTR(C$, "M")
IF J = 0 THEN AUTO = 1: J = INSTR(C$, "A")
IF AUTO = 1 AND computer = 0 THEN
    CLS
    COLOR RED, BACKGROUND
    PRINT WOFFICER$; " reports, 'We cannot fire the phasors on automatic with a damaged computer, Captain.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF J = 0 THEN COLOR RED, BACKGROUND: PRINT "Wrong syntax": COLOR BLUE, BACKGROUND: EXIT SUB
I = LEN(C$)
C$ = LTRIM$(RIGHT$(C$, I - J))
I = LEN(C$)
C$ = RTRIM$(C$)
EPHAS = VAL(C$)
IF EPHAS > 1000 AND ENERGY > 1000 THEN EPHAS = 1000
IF EPHAS < 1 AND ENERGY > 1000 THEN EPHAS = 1000
IF EPHAS < 1 AND ENERGY < 1000 THEN EPHAS = ENERGY / 2
IF EPHAS < ENERGY AND ENERGY < 1000 THEN EPHAS = ENERGY / 2
IF EPHAS > ENERGY THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " says, 'But Captain, we need a wee bit more energy to do that !'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
L = 0
ECLOAK = 0
FOR I = 1 TO 9
    FOR J = 1 TO 9
        IF SEC$(I, J) = "K" OR SEC$(I, J) = "S" OR SEC$(I, J) = "C" OR (SEC$(I, J) = "R" AND STRENGTH(I, J) <= 1500) THEN
            IF STRENGTH(I, J) <= 0 THEN
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " reports, 'Enemy ";
                IF WOFFICER$ = "Chekov" THEN PRINT "wessel"; ELSE PRINT "vessel";
                PRINT "at "; I; ","; J; " just exploded, Sir.'"
                COLOR BLUE, BACKGROUND
                IF SEC$(I, J) = "R" OR SEC$(I, J) = "." THEN
                    ROMULANS = ROMULANS - 1
                    SEC$(I, J) = "."
                    STRENGTH(I, J) = 1000000!
                    CALL SECDRAW
                    GOTO NEXEN
                END IF
                Klingons = Klingons - 1
                ENEMY = ENEMY - 1
                STRENGTH(I, J) = 1000000!
                IF SEC$(I, J) = "K" THEN
                    KLINGS = KLINGS - 1
                    IF KLINGS < 1 THEN KLINGS = 0
                    HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                    HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                    GAL$(SX, SY) = HGAL$(SX, SY)
                END IF
                SEC$(I, J) = "."
                CALL SECDRAW
                GOTO NEXEN
            END IF
            L = L + 1
            THREATX(L) = I: THREATY(L) = J
            THREATP(L) = SQR((I - EX) ^ 2 + (J - EY) ^ 2)
            THREATP(L) = STRENGTH(I, J) / (THREATP(L) * 1000)
        END IF
        IF SEC$(I, J) = CHR$(21) THEN
            COLOR RED, BACKGROUND
            PRINT "COMPUTER : "; benemies$; " at "; I; ","; J; " has neutronium hull. Phasors usless against it."
            COLOR BLUE, BACKGROUND
        END IF
    NEXEN: NEXT J
NEXT I
FOR II = 1 TO L
    DIST = SQR((THREATX(II) - EX) ^ 2 + (THREATY(II) - EY) ^ 2)
    KEN(II) = 200 * THREATP(II) + 200 * (DIST * THREATP(II))
NEXT II
FOR I = 1 TO L
    FOR J = 2 TO I
        IF THREATP(J) > THREATP(J - 1) THEN
            TEMP = KEN(J - 1): KEN(J - 1) = KEN(J): KEN(J) = TEMP
            TEMP = THREATX(J - 1): THREATX(J - 1) = THREATX(J): THREATX(J) = TEMP
            TEMP = THREATY(J - 1): THREATY(J - 1) = THREATY(J): THREATY(J) = TEMP
            TEMP = THREATP(J - 1): THREATP(J - 1) = THREATP(J): THREATP(J) = TEMP
        END IF
    NEXT J
NEXT I
IF AUTO = 0 THEN GOTO PHMANUAL
FOR I = 1 TO L
    IF SEC$(THREATX(I), THREATY(I)) = "." THEN GOTO PHAENDI
    IF KEN(I) * (1 + SCPEN) > EPHAS AND EPHAS <> 0 THEN GOTO PHADAMI
    EPHAS = EPHAS - (KEN(I) * (1 + SCPEN))
    ENERGY = ENERGY - (KEN(I) * (1 + SCPEN))
    STRENGTH(THREATX(I), THREATY(I)) = 0
    IF SEC$(THREATX(I), THREATY(I)) <> "R" THEN Klingons = Klingons - 1
    ENEMY = ENEMY - 1
    COLOR RED, BACKGROUND
    STRENGTH(I, J) = 1000000!
    IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";: KLINGS = KLINGS - 1
    IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
    PRINT THREATX(I); ","; THREATY(I); " DESTROYED. "; KEN(I); " units required."
    IF KLINGS < 1 THEN KLINGS = 0
    HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
    HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
    GAL$(SX, SY) = HGAL$(SX, SY)
    IF SEC$(THREATX(I), THREATY(I)) = "C" THEN
        commanders = commanders - 1
        FOR SI = 1 TO 20
            IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
        NEXT SI
    END IF
    IF SEC$(THREATX(I), THREATY(I)) = "S" THEN
        SUPERS = SUPERS - 1
        FOR SI = 1 TO 3
            IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
        NEXT SI
    END IF
    IF SEC$(THREATX(I), THREATY(I)) = "R" THEN ROMULANS = ROMULANS - 1
    SEC$(THREATX(I), THREATY(I)) = "."
    GOTO PHAENDI
    PHADAMI: DIST = SQR((EX - THREATX(I)) ^ 2 + (EY - THREATY(I)) ^ 2)
    STRENGTH(THREATX(I), THREATY(I)) = STRENGTH(THREATX(I), THREATY(I)) - (EPHAS / DIST)
    IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";
    IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
    PRINT THREATX(I); ","; THREATY(I); " hit with "; (EPHAS / DIST); " units."
PHAENDI: NEXT I
COLOR BLUE, BACKGROUND
IF ENEMY < 1 THEN CONDITION = 1
CALL MAKEDISPLAY
EXIT SUB
PHMANUAL: COLOR RED, BACKGROUND: PRINT ENERGY; " units available to fire phasors."
PFIRET = 0
FOR I = 1 TO L
    IF computer = 1 THEN PRINT KEN(I) * (1 + SCPEN); " for a kill. ";
    PRINT "Units to fire at ";
    IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";
    IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "R" AND STRENGTH(THREATX(I), THREATY(I)) <= 1500 THEN PRINT "Romulan at ";
    PRINT THREATX(I); ","; THREATY(I); "  ";
    INPUT PFIRE(I)
NEXT I
FOR I = 1 TO L
    IF PFIRE(I) < KEN(I) AND KEN(I) <> 0 THEN GOTO MPHADAMI
    IF PFIRE(I) >= KEN(I) * (1 + SCPEN) THEN
        ENERGY = ENERGY - PFIRE(I)
        STRENGTH(THREATX(I), THREATY(I)) = 0
        Klingons = Klingons - 1
        ENEMY = ENEMY - 1
        COLOR RED, BACKGROUND
        STRENGTH(I, J) = 1000000!
        IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";: KLINGS = KLINGS - 1
        IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
        IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
        IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
        PRINT THREATX(I); ","; THREATY(I); " DESTROYED. "; PFIRE(I); " units fired."
        IF KLINGS < 1 THEN KLINGS = 0
        HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
        HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
        GAL$(SX, SY) = HGAL$(SX, SY)
        IF SEC$(THREATX(I), THREATY(I)) = "C" THEN
            commanders = commanders - 1
            FOR SI = 1 TO 20
                IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
            NEXT SI
        END IF
        IF SEC$(THREATX(I), THREATY(I)) = "S" THEN
            SUPERS = SUPERS - 1
            FOR SI = 1 TO 3
                IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
            NEXT SI
        END IF
        SEC$(THREATX(I), THREATY(I)) = "."
        GOTO MPHAENDI
    END IF
    MPHADAMI: ENERGY = ENERGY - PFIRE(I)
    DIST = SQR((EX - THREATX(I)) ^ 2 + (EY - THREATY(I)) ^ 2)
    STRENGTH(THREATX(I), THREATY(I)) = STRENGTH(THREATX(I), THREATY(I)) - (PFIRE(I) / DIST)
    IF SEC$(THREATX(I), THREATY(I)) = "K" THEN PRINT MENEMIES$; " at ";
    IF SEC$(THREATX(I), THREATY(I)) = "C" THEN PRINT MENEMIES$; " Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "S" THEN PRINT MENEMIES$; " Super Commander at ";
    IF SEC$(THREATX(I), THREATY(I)) = "R" THEN PRINT "Romulan at ";
    PRINT THREATX(I); ","; THREATY(I); " hit with "; (PFIRE(I) / DIST); " units."
    MPHAENDI: PFIRET = PFIRET + PFIRE(I)
    IF PFIRET > 1000 AND RND > .5 THEN
        COLOR RED, BACKGROUND
        PRINT WOFFICER$; " reports, 'Phasors overheated, Captain !'"
        PHASORS = 0
        DLEN(3) = INT(30 * RND) / 10
        GOTO PHEAT
    END IF
NEXT I
PHEAT: COLOR BLUE, BACKGROUND
IF ENEMY < 1 THEN CONDITION = 1
IF ENERGY < 0 THEN ENERGY = 0
CALL MAKEDISPLAY
END SUB

SUB PROLOG
'
'       HERE WE TELL ABOUT THE GAME
'
SHARED MENEMIES$, LEVEL
COLOR BLACK, BACKGROUND
CLS
COLOR RED, BACKGROUND
PRINT "STARFLEET ORDERS, STARDATE:"; IDATE
COLOR BLACK, BACKGROUND
PRINT "Congratulations, you are now in command of the United"
PRINT "Federation of Planets Starship, the U.S.S. Enterprise."
PRINT "Unfortunately, negotiations with the "; MENEMIES$; "s have"
PRINT "broken down. A state of war exists."
PRINT ""
PRINT "Your mission is most distasteful:"
PRINT "You are to search out and destroy ";
COLOR FRED, BACKGROUND
PRINT "ALL ";
COLOR BLACK, BACKGROUND
PRINT MENEMIES$; "s that you encounter."
PRINT
IF LEVEL > 1 THEN
    PRINT "Intelligence reports that the Romulans are helping the "; MENEMIES$; "s"
    PRINT "and have just implemented a breakthrough in cloaking technology."
    COLOR RED, BACKGROUND
    PRINT
    PRINT "REPORTS ARE THAT EVEN WITH ALL SHORT RANGE SENSORS TRAINED ON"
    PRINT "ROMULAN SHIPS WITH THE NEW CLOAKING DEVICE, THEY WILL STAY"
    PRINT "INVISIBLE IF THEY HAVE ENOUGH POWER."
    PRINT
    COLOR BLACK, BACKGROUND
END IF
IF LEVEL = 2 THEN
    PRINT "Intelligence reports "; BERZERKS; " sightings of "; benemies$; "s"
    PRINT "recently. They are quite dangerous."
    PRINT
    PRINT "Intelligence also reports interception of "; MENEMIES$; " communications"
    PRINT "which may indicate as many as "; commanders + CINT(RND * 2); " "; MENEMIES$; " Commander Ships"
    PRINT "and at least one of the "; MENEMIES$; " Emperor's Super Commanders may be operational."
    PRINT
END IF
PRINT "Strike any key to begin your mission..."
READYTOGO: IF INKEY$ = "" THEN GOTO READYTOGO
END SUB

SUB REPAIRS
'
' This routine checks to see if repairs are finished
'
' DLEN(1) = DRIVE REPAIR TIME
' DLEN(2) = SHIELD REPAIR TIME
' DLEN(3) = PHASOR REPAIR TIME
' DLEN(4) = TORPEDOE TUBE REPAIR TIME
' DLEN(5) = CLOAK REPAIR TIME
' DLEN(6) = COMPUTER REPAIR TIME
' DLEN(7) = LIFE SUPPORT REPAIR TIME
' DLEN(8) = CRYSTAL DECAY TIME
SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life, ODATE
SHARED TRANSPORTER, SX, SY, SHIP$, CLOAK, computer, DLEN(), BACKGROUND
DIM ELEN(8)
FOR I = 1 TO 8
    ELEN(I) = DLEN(I)
NEXT I
IF CONDITION < 0 THEN
    FOR I = 1 TO 8
        ELEN(I) = DLEN(I) / 20
    NEXT I
END IF
IF SDATE - ODATE > ELEN(1) AND ELEN(1) > 0 THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " reports, 'Captain, the warp engines are operational."
    DLEN(1) = 0
END IF
IF SDATE - ODATE > ELEN(2) AND ELEN(2) > 0 THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " reports, 'Captain, the shields are operational."
    DLEN(2) = 0
    SHIELDS = 1
END IF
IF SDATE - ODATE > ELEN(3) AND ELEN(3) > 0 THEN
    COLOR RED, BACKGROUND
    PRINT WOFFICER$; " reports, 'Captain, the phasors are operational."
    DLEN(3) = 0
    PHASORS = 1
END IF
IF SDATE - ODATE > ELEN(4) AND ELEN(4) > 0 THEN
    COLOR RED, BACKGROUND
    PRINT SOFFICER$; " reports, 'Captain, the photon torpedoes are operational."
    DLEN(4) = 0
    TORPEDOES = -1 * TORPEDOES
END IF
IF SDATE - ODATE > ELEN(5) AND ELEN(5) > 0 THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " reports, 'Captain, that cloaking contraption is operational."
    DLEN(5) = 0
    CLOAK = 1
END IF
IF SDATE - ODATE > ELEN(6) AND ELEN(6) > 0 THEN
    COLOR RED, BACKGROUND
    PRINT SOFFICER$; " reports, 'Captain, the ship's computers are operational."
    DLEN(6) = 0
    computer = 1
END IF
IF SDATE - ODATE > ELEN(7) AND ELEN(7) > 0 THEN
    COLOR RED, BACKGROUND
    PRINT "Engineering reports, 'Captain, the life support systems are operational."
    DLEN(7) = 0
    life = 1
END IF
IF SDATE - ODATE > ELEN(8) AND ELEN(8) > 0 AND CONDITION >= 0 THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " reports, 'Captain, the dilithium crystals are expended."
    DLEN(8) = 0
    ENERGY = 0
    SHIELDS = 0
END IF
IF SDATE - ODATE > ELEN(8) AND ELEN(8) > 0 AND CONDITION < 0 THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " reports, 'Captain, the dilithium crystals have been replaced."
    DLEN(8) = 0
    CRYSTALS = 1
END IF
FOR I = 1 TO 8
    IF DLEN(I) > 0 THEN DLEN(I) = DLEN(I) - ABS(SDATE - ODATE)
    IF DLEN(I) < 0 THEN DLEN(I) = 0
NEXT I
CALL MAKEDISPLAY
END SUB

SUB SETWARP
'
' Here we set the warp speed
'
SHARED SPEED, drive, C$, BACKGROUND
COLOR RED, BACKGROUND
SPEED = VAL(RIGHT$(C$, 2))
IF SPEED = 0 GOTO NSPEED
GOTO SSPEED
NSPEED: PRINT "New warp setting (0-10) ";
COLOR BLUE, BACKGROUND
INPUT SPEED
SSPEED: IF SPEED < 0 OR SPEED > 10 THEN GOTO NSPEED
IF SPEED < 1 THEN drive = 1 ELSE drive = 2
IF SPEED = 0 THEN drive = 0
CALL MAKEDISPLAY
END SUB

SUB SSCAN
'
'       THIS SUBROUTINE PERFORMS A SHORT-RANGE SCAN OF THE
'       CURRENT SECTOR
'
SHARED SEC$(), PLANC(), EX, EY, SX, SY, PLANETS, BFLAG, PLANI(), PLANJ(), SEC$(), STRENGTH()
SHARED BACKGROUND
TIMER OFF
VIEW PRINT 1 TO 25
COLOR BLACK, BACKGROUND
CLS
PRINT
PRINT
PRINT SOFFICER$; " reports :"
PRINT
FOR I = 1 TO 9
    FOR J = 1 TO 9
        IF SEC$(J, I) = "B" THEN PRINT "Star Base at sector "; J; ","; I; "."
        IF SEC$(J, I) = "K" THEN PRINT MENEMIES$; " at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
        IF SEC$(J, I) = "S" THEN PRINT MENEMIES$; " Super Commander at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
        IF SEC$(J, I) = "C" THEN PRINT MENEMIES$; " Commander at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
        IF SEC$(J, I) = "P" THEN
            PRINT "Planet at "; J; ","; I;
            FOR K = 1 TO PLANETS
                IF PLANI(K) = SX AND PLANJ(K) = SY AND PLANC(K) = 1 THEN PRINT " of class M with indications of Dilithium Crystals.";
                IF PLANI(K) = SX AND PLANJ(K) = SY AND PLANC(K) = 0 AND RND < .3 THEN PRINT " of class M with indications of Dilithium Crystals.";
            NEXT K
            PRINT ""
        END IF
        IF SEC$(J, I) = "E" OR SEC$(J, I) = "Q" THEN PRINT SHIP$; " located at "; J; ","; I; "."
        IF SEC$(J, I) = CHR$(21) THEN
            PRINT benemies$; " at "; J; ","; I; " with a solid Neutronium hull."
            IF BFLAG = 1 THEN PRINT "     The "; benemies$; " seems annoyed."
        END IF
        IF SEC$(J, I) = CHR$(15) THEN PRINT "Star at "; J; ","; I; "."
        IF SEC$(J, I) = "R" AND STRENGTH(J, I) < 1500 THEN PRINT "Romulan detected at "; J; ","; I; " of estimated strength of "; STRENGTH(J, I); " energy units."
        IF SEC$(J, I) = " " THEN PRINT "Black Hole at "; J; ","; I; "."
    NEXT J
NEXT I
PRINT "Hit any key ...."
WRANGE: A$ = INKEY$
IF A$ = "" THEN GOTO WRANGE
CLS
END SUB

SUB WORKSHEET
'
'       This subroutine makes a fake worksheet screen
'
'       User hits TAB to return to the game
SHARED BACKGROUND
TIMER OFF
SWORK: VIEW PRINT 1 TO 25
COLOR 7, 0
CLS
PRINT
COLOR 7, 0
PRINT
PRINT
COLOR BLACK, 7
LOCATE 4, 1
PRINT STRING$(79, " ");
LOCATE 4, 1
PRINT "       A         B         C         D         E         F         G         H  "
FOR I = 1 TO 20
    COLOR BLACK, 7
    PRINT USING "##"; I;
    COLOR 7, 0
    PRINT USING " #.#######"; 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1), 3 * RND(1);
    PRINT USING " #.#####"; 3 * RND(1)
NEXT I
COLOR 7, 0
X = 3 * RND(1)
COLOR 0, 7
LOCATE 7, 64
PRINT USING "#.#######"; X;
COLOR 7, 0
LOCATE 1, 1
PRINT "G3:";
PRINT USING "#.#######"; X;
COLOR 16, 7: LOCATE 1, 76: PRINT "WAIT";
COLOR 7, 0
HOLDITHERE: A$ = INKEY$
IF A$ <> CHR$(9) THEN
    LOCATE 25, 1
    PRINT DATE$, TIME$;
    IF A$ = "%" THEN
        CLS
        PRINT
        PRINT
        PRINT
        PRINT
        PRINT
        PRINT "SYSTEM ERROR - ST Keyboard Handler Error"
        END
    END IF
    IF A$ = "/" THEN
        CLS
        PRINT
        PRINT
        PRINT
        PRINT
        PRINT
        PRINT "Type EXIT to return to program..."
        SHELL
        GOTO SWORK
    END IF
    GOTO HOLDITHERE
END IF
COLOR BLACK, BACKGROUND
CLS
CALL MAKEDISPLAY
TIMER ON
END SUB

'
'       This module is part of TREK written by Burns Lab
'       University of Florida
'       Physics Department
'
'       BETA TEST VERSION 3.0   LAST UPDATED 5-JAN-91
'


SUB ABANDON
'
' This routine allows one to abandon the Enterprise as
' long as there is a Star Base. If no bases, you die.
'
SHARED SHIP$, BACKGROUND
TIMER OFF
IF CONDITION < 0 THEN
    COLOR RED, BACKGROUND
    PRINT DOCTOR$; " exclaims, 'Are you having those memory lapses again, Captain ?'"
    COLOR BLUE, BACKGROUND
    TIMER ON
    EXIT SUB
END IF
BEEP
COLOR RED, BACKGROUND
PRINT "ABANDON SHIP ! ABANDON SHIP ! ALL HANDS, ABANDON SHIP !"
BEEP
ABTIME1: CALL DELAY(5)
IF BASES = 0 THEN
    COLOR RED, BACKGROUND
    PRINT "You and your crew drift in lifeboats for months, starving"
    PRINT "to death while the "; MENEMIES$; "s win the war. Your name becomes "
    PRINT "equated with cowardice."
    ABTIME2: CALL DELAY(5)
    COLOR BLUE, BACKGROUND
    SHIP$ = "U.S.S. QUAHOG"
    CALL ENDGAME: EXIT SUB
    EXIT SUB
END IF
IF SHIP$ = "U.S.S. QUAHOG" THEN
    COLOR RED, BACKGROUND
    PRINT SOFFICER$; " says, 'Star Fleet will execute us if we abandon again, Captain.'"
    PRINT "  'I think I would rather disobey this order.'"
    COLOR BLUE, BACKGROUND
    TIMER ON
    EXIT SUB
END IF
TIMER OFF
VIEW PRINT 1 TO 24
CLS
COLOR RED, BACKGROUND
PRINT "You and your crew drift in space for weeks. Finally, you are rescued"
PRINT "by a Alligatorian brothel-boat and returned to Star Fleet. After much"
PRINT "deliberation, it is decided to let you have another ship, although you"
PRINT "cannot be trusted with one of the good ones. You are given command of"
PRINT "the U.S.S. Quahog."
COLOR BLUE, BACKGROUND
ABTIME3: CALL DELAY(15)
SHIP$ = "U.S.S. QUAHOG"
ENERGY = 10000
TORPEDOES = 10
SHENERGY = 5000
FOR I = 1 TO 9
    FOR J = 1 TO 9
        X = 0
        X = INSTR(GAL$(I, J), "B")
        IF X <> 0 THEN GOTO PBASE
    NEXT J
NEXT I
PBASE: SX = I: SY = J
EX = INT(8 * RND) + 1: EY = INT(8 * RND) + 1
CONDITION = -1
CLS
LOCATE 24, 1
CALL INITSECT
CALL MAKEDISPLAY
TIMER ON
END SUB

SUB CHNGCLOAK
'
' This routine changes the cloaking device status
'
SHARED BACKGROUND
IF CLOAK = 1 OR CLOAK = 0 THEN ENERGY = ENERGY - 100
IF ENERGY <= 0 THEN ENERGY = 0: COLOR RED, BACKGROUND: PRINT "NO ENERGY": CALL MAKEDISPLAY: EXIT SUB
IF CLOAK = 0 THEN CLOAK = 1: CALL MAKEDISPLAY: EXIT SUB
IF CLOAK = 1 THEN CLOAK = 0: CALL MAKEDISPLAY: EXIT SUB
IF CLOAK < 0 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'Cloaking Device damaged, Captain.'"
    EXIT SUB
END IF

END SUB

SUB DOCK
'
' Here we dock the enterprise
'
SHARED ENERGY, TORPEDOES, SHENERGY, EX, EY, SEC$(), SHIP$, TDOWN, BACKGROUND
X = 0: TDOWN = 0
FOR I = EX - 1 TO EX + 1
    FOR J = EY - 1 TO EY + 1
        IF J < 1 OR J > 9 THEN GOTO DENDJ
        IF I < 1 OR I > 9 THEN GOTO DENDI
        X = X + INSTR(SEC$(I, J), "B")
    DENDJ: NEXT J
DENDI: NEXT I
IF X = 0 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'We are not at a Star Base, Captian.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
CONDITION = -1 * CONDITION
IF SHIP$ = "U.S.S. ENTERPRISE" THEN
    ENERGY = 20000
    TORPEDOES = 20
    SHENERGY = 10000
ELSE
    ENERGY = 10000
    TORPEDOES = 10
    SHENERGY = 5000
END IF
CALL MAKEDISPLAY
END SUB

SUB ENDGAME
'
' Here we end the game
'
SHARED ENDOFGAME, HELPCOUNT, BASEDESTROYED, PLANETSLOST, Klingons, OKLINGONS
SHARED SUPERS, OSUPERS, ROMULANS, oromulans, commanders, OCOMMANDERS, KBERZERKERS
SHARED SDATE, IDATE, BACKGROUND, BEZA()
TIMER OFF
VIEW PRINT 1 TO 24
CLS
HELPPOINTS = -500 * HELPCOUNT
BASEPOINTS = -5000 * BASEDESTROYED
PLANETPOINTS = -1000 * PLANETSLOST
KLINGONPOINTS = 100 * (OKLINGONS - Klingons)
SUPERPOINTS = 1000 * (OSUPERS - SUPERS)
ROMPOINTS = 500 * (oromulans - ROMULANS)
COMMPOINTS = 500 * (OCOMMANDERS - commanders)
BERZERKPOINTS = 3000 * KBERZERKERS
TIMEPOINTS = -100 * (SDATE - IDATE)
IF SHIP$ = "U.S.S. QUAHOG" THEN ABANDONPTS = -5000
POINTOTAL = BASEPOINTS + PLANETPOINTS + KLINGONPOINTS + SUPERPOINTS + ROMPOINTS
POINTOTAL = POINTOTAL + COMMPOINTS + BERZERKPOINTS + TIMEPOINTS + HELPPOINTS
POINTOTAL = POINTOTAL + ABANDONPTS
COLOR RED, BACKGROUND
PRINT "Your score for this game is as follows:"
IF KLINGONPOINTS <> 0 THEN PRINT (OKLINGONS - Klingons); " "; MENEMIES$; " Kills :   "; KLINGONPOINTS
IF COMMPOINTS <> 0 THEN PRINT (OCOMMANDERS - commanders); " Commander Kills : "; COMMPOINTS
IF SUPERPOINTS <> 0 THEN PRINT (OSUPERS - SUPERS); " Super Commander Kills : "; SUPERPOINTS
IF ROMPOINTS <> 0 THEN PRINT (oromulans - ROMULANS); " Romulan Kills : "; ROMPOINTS
IF BERZERKPOINTS <> 0 THEN PRINT KBERZERKERS; " "; benemies$; " Kills : "; BERZERKPOINTS
IF BASEPOINTS <> 0 THEN
    PRINT "For destroying "; BASEDESTROYED; " Star Bases : "; BASEPOINTS
END IF
IF PLANETPOINTS <> 0 THEN
    PRINT "For destroying "; PLANETSLOST; " Planets : "; PLANETPOINTS
END IF
BFLAG = 0
FOR I = 1 TO BERZERKS
    IF BEZA(I) = 1 THEN BFLAG = BFLAG + 1
NEXT I
IF BFLAG <> 0 THEN
    PRINT "For being dumb enough to annoy a "; benemies$; " : "; -1 * BFLAG * 200
END IF
IF HELPCOUNT > 0 THEN PRINT "For needing to be helped by a Star Base : "; HELPPOINTS
IF EATEN <> 0 THEN PRINT "For letting a "; benemies$; " kill you : -2000"
IF SHIP$ = "U.S.S. QUAHOG" THEN PRINT "For abandoning the Enterprise : -5000"
PRINT "For taking your sweet "
PRINT "time on this mission : "; TIMEPOINTS
PRINT
POINTOTAL = POINTOTAL - 1 * BFLAG * 200 - 2000 * EATEN
PRINT "TOTAL SCORE : "; POINTOTAL
PRINT: PRINT: PRINT: PRINT
PRINT "Would you like to play another game (<cr>=Y) ";: INPUT A$
IF A$ = "" THEN A$ = "Y"
A$ = UCASE$(A$)
IF LEFT$(A$, 1) = "N" THEN
    COLOR 7, 0
    SCREEN 0
    CLS
    END
END IF
ENDOFGAME = 1
END SUB

SUB GALDRAW STATIC
'
' This subroutine redraws the whole GALAXY MAP
'
SHARED SX, SY, GAL$(), CONDITION, BACKGROUND
TIMER OFF
IF SX < 1 THEN SX = 1
IF SX > 9 THEN SX = 9
IF SY < 1 THEN SY = 1
IF SY > 9 THEN SY = 9
CRG = CSRLIN: CCG = POS(0)
VIEW PRINT 1 TO 24
COLOR BLUE, BACKGROUND
LOCATE 1, 1
PRINT "            Explored Galaxy Map                    "
PRINT
PRINT "     1   2   3   4   5   6   7   8   9         "
FOR I = 1 TO 9
    COLOR BLUE, BACKGROUND
    PRINT STR$(I); " ";
    COLOR BLACK, BACKGROUND
    FOR J = 1 TO 9
        IF SX = J AND SY = I THEN
            COLOR FRED, BACKGROUND
            PRINT " "; GAL$(J, I);
            COLOR BLACK, BACKGROUND
            GOTO ENDGAL
        END IF
        IF INSTR(GAL$(J, I), "B") <> 0 THEN COLOR PURPLE, BACKGROUND ELSE COLOR BLACK, BACKGROUND
        PRINT " "; GAL$(J, I);
    ENDGAL: NEXT J
    COLOR BLUE, BACKGROUND
    PRINT STR$(I)
NEXT I
VIEW PRINT 21 TO 24
IF CRG < 21 THEN CRG = 24: CCG = 1
LOCATE CRG, CCG
IF CONDITION >= 0 THEN TIMER ON
END SUB

SUB HELP
'
' We do the response for help here
'
SHARED SX, SY, EX, EY, BASES, CONDITION, GAL$(), HELPCOUNT, BACKGROUND
DIM BASEX(6), BASEY(6), BASED(6)
HELPCOUNT = HELPCOUNT + 1
IF CONDITION < 0 THEN
    COLOR RED, BACKGROUND
    PRINT DOCTOR$; " exclaims, 'Are you having those memory lapses again, Captain ?'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF BASES = 0 THEN
    COLOR RED, BACKGROUND
    PRINT SOFFICER$; " says, 'No bases left, Captain. We are on our own.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
CLS
COLOR BLUE, BACKGROUND
PRINT "Star Fleet attempts to use the experimental (Patent Pending)";
COLOR RED, BACKGROUND
PRINT " GALACTIC TRANSPORTER BEAM."
COLOR BLUE, BACKGROUND
BAS = 0
FOR I = 1 TO 9
    FOR J = 1 TO 9
        X = 0
        X = INSTR(GAL$(I, J), "B")
        IF X <> 0 THEN
            BAS = BAS + 1
            BASEX(BAS) = I
            BASEY(BAS) = J
            BASED(BAS) = SQR((I - SX) ^ 2 + (J - SY) ^ 2)
        END IF
    NEXT J
NEXT I
NEARX = BASEX(BAS)
NEARY = BASEY(BAS)
NEARD = BASED(BAS)
FOR I = 1 TO BAS
    IF BASED(I) < NEARD THEN
        NEARX = BASEX(I)
        NEARY = BASEY(I)
        NEARD = BASED(I)
    END IF
NEXT I
PRINT "Nearest Star Base is in quadrant "; NEARX; ","; NEARY
HELPDELAY1: CALL DELAY(2)
FOR I = 1 TO 3
    PRINT "Materialization attempt # "; I; " ";
    HELPDELAY2: CALL DELAY(.5)
    IF 50 * RND > NEARD ^ 2 THEN
        COLOR RED, BACKGROUND
        PRINT "SUCCEEDS !!"
        COLOR BLUE, BACKGROUND
        SX = NEARX: SY = NEARY
        EX = INT(8 * RND) + 1: EY = INT(8 * RND) + 1
        CONDITION = -1
        CALL INITSECT
        CALL MAKEDISPLAY
        EXIT SUB
    ELSE
        PRINT "FAILS"
    END IF
NEXT I
CLS
COLOR RED, BACKGROUND: PRINT "Star Fleet to Enterprise: We cannot help you."
PRINT "Good Luck Enterprise..."
COLOR BLUE, BACKGROUND
HELPDELAY3: CALL DELAY(3)
END SUB

SUB INITSECT
'
' We intinalize the current sector upon entry of the Enterprise
'
SHARED SX, SY, SHIP$, EX, EY, BEZI(), BEZJ(), BEZA(), PLANI(), PLANJ()
SHARED ROMULANS, commanders, SUPERS, BERZERKERS, PLANETS, BASES
SHARED CONDITION, KLINGS, ENEMY, LEVEL, BACKGROUND, SEC$(), STRENGTH()
SHARED SUPI(), SUPJ(), COMI(), COMJ()
'ON ERROR GOTO ERRMESSAGE
ON ERROR GOTO 0
COMMS = 0: KLINGS = 0: RKLINGS = 0: ENEMY = 0
KEY(1) ON
FOR I = 1 TO 9
    FOR J = 1 TO 9
        SEC$(I, J) = "."
        STRENGTH(I, J) = 1000000!
    NEXT J
NEXT I
SEC$(EX, EY) = "E" ' Place Enterprise at its entry location

BFLAG = 0
FOR I = 1 TO BERZERKS
    IF BEZA(I) = 1 THEN BEZI(I) = SX: BEZJ(I) = SY: BFLAG = BFLAG + 1
NEXT I
IF BFLAG = 1 THEN
    COLOR RED, BACKGROUND
    PRINT SOFFICER$; " reports, 'That "; benemies$; " we annoyed has followed"
    PRINT "us to this quadrant, Captain.'"
    COLOR BLUE, BACKGROUND
END IF
IF BFLAG > 1 THEN
    COLOR RED, BACKGROUND
    PRINT "'Fascinating !' exclaims "; SOFFICER$; ". 'There are now "; BFLAG; " of them following us."
    PRINT "The "; benemies$; "s seem to be cooperating in order to destroy us.'"
    COLOR BLUE, BACKGROUND
END IF
IF CONDITION < 0 THEN
    DOCKED: X = CINT(RND): Y = CINT(RND)
    X = 2 * X - 1: Y = 2 * Y - 1
    IF (X + EX) < 1 OR (X + EX) > 9 THEN GOTO DOCKED
    IF (Y + EY) < 1 OR (Y + EY) > 9 THEN GOTO DOCKED
    SEC$(X + EX, Y + EY) = "B"
    GOTO SBERZ
END IF
IF INSTR(HGAL$(SX, SY), "B") <> 0 THEN
    IBASE: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO IBASE
    SEC$(X, Y) = "B"
END IF
SBERZ: FOR I = 1 TO BERZERKS
    IF BEZI(I) <> SX OR BEZJ(I) <> SY THEN GOTO EBERZ
    IBERZ: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO IBERZ
    SEC$(X, Y) = CHR$(21): ENEMY = ENEMY + 1
EBERZ: NEXT I
IF ROMULANS > 0 AND RND > .2 THEN
    ROM = 3 * RND
    IF ROM > ROMULANS THEN ROM = ROMULANS
    FOR I = 1 TO ROM
        IROM: X = INT(8 * RND) + 1: Y = INT(8 * RND)
        SEC$(X, Y) = "R"
        STRENGTH(X, Y) = 1000 + 1500 * RND
    NEXT I
END IF
FOR I = 1 TO PLANETS
    IF PLANI(I) <> SX OR PLANJ(I) <> SY THEN GOTO EPLAN
    IPLAN: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO IPLAN
    SEC$(X, Y) = "P"
EPLAN: NEXT I
FOR I = 1 TO SUPERS
    IF SUPI(I) <> SX OR SUPJ(I) <> SY THEN GOTO ESUP
    ISUP: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO ISUP
    SEC$(X, Y) = "S"
    STRENGTH(X, Y) = 3000: ENEMY = ENEMY + 1
ESUP: NEXT I
FOR I = 1 TO commanders
    IF COMI(I) <> SX OR COMJ(I) <> SY THEN GOTO ECOM
    ICOM: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO ICOM
    SEC$(X, Y) = "C"
    STRENGTH(X, Y) = 1500: ENEMY = ENEMY + 1
ECOM: NEXT I
IF RIGHT$(HGAL$(SX, SY), 1) = " " THEN STARS = 0 ELSE STARS = VAL(RIGHT$(HGAL$(SX, SY), 1))
IF LEFT$(HGAL$(SX, SY), 1) = " " THEN KLINGONI = 0 ELSE KLINGONI = VAL(LEFT$(HGAL$(SX, SY), 1))
GAL$(SX, SY) = RIGHT$(HGAL$(SX, SY), 3)
FOR I = 1 TO KLINGONI
    IKLINGS: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO IKLINGS
    SEC$(X, Y) = "K": KLINGS = KLINGS + 1: RKLINGS = RKLINGS + 1
    STRENGTH(X, Y) = 1000: ENEMY = ENEMY + 1
NEXT I
IF LEVEL = 1 THEN GOTO IISTARS
IBHOLES: BHOLES = CINT(LEVEL * RND)
FOR I = 1 TO BHOLES
    IIBHOLES: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO IIBHOLES
    SEC$(X, Y) = " "
NEXT I
IISTARS: FOR I = 1 TO STARS
    ISTARS: X = INT(8 * RND) + 1: Y = INT(8 * RND)
    IF SEC$(X, Y) <> "." THEN GOTO ISTARS
    SEC$(X, Y) = CHR$(15)
NEXT I
IF KLINGS > 0 THEN
    COLOR RED, BACKGROUND
    PRINT WOFFICER$; " reports, '"; KLINGS; " "; MENEMIES$; "s in this quadrant !'"
    IF KLINGS > RKLINGS THEN PRINT "That's "; (KLINGS - RKLINGS); " more than Long Range Sensors indicated.'"
    IF KLINGS > RKLINGS THEN PRINT "'They seem to have been using a long range cloaking device, Captain.'"
    COLOR BLUE, BACKGROUND
END IF
IF ENEMY > 0 THEN CONDITION = 3
EXIT SUB
END SUB

SUB KATTACKS
'
' This is where the Klingons and Romulans attack the ship
'
SHARED SX, SY, SHIP$, EX, EY
SHARED ROMULANS, commanders, SUPERS, BERZERKS, PLANETS, BASES
SHARED KLINGS, ENEMY, Klingons
SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
SHARED TRANSPORTER, C$, computer, BACKGROUND
SHARED SEC$(), STRENGTH()
SUPHERE = 0
FOR I = 1 TO 9
    FOR J = 1 TO 9
        IF SEC$(I, J) = "S" THEN SUPHERE = 1
    NEXT J
NEXT I
IF ECLOAK = 1 AND RND < .9 AND SUPHERE = 0 THEN EXIT SUB
FOR I = 1 TO 9
    FOR J = 1 TO 9
        IF SEC$(I, J) <> "R" AND SEC$(I, J) <> "K" AND SEC$(I, J) <> "C" AND SEC$(I, J) <> "S" THEN GOTO KATTENDJ
        IF STRENGTH(I, J) > 4000 THEN STRENGTH(I, J) = 4000
        IF STRENGTH(I, J) <= 0 THEN
            COLOR RED, BACKGROUND
            PRINT WOFFICER$; " reports, 'Enemy ";
            IF WOFFICER$ = "Chekov" THEN PRINT "wessel"; ELSE PRINT "vessel";
            PRINT " at "; I; ","; J; " just exploded, Sir.'"
            COLOR BLUE, BACKGROUND
            ENEMY = ENEMY - 1: Klingons = Klingons - 1
            IF SEC$(I, J) = "S" THEN
                SUPERS = SUPERS - 1
                FOR SI = 1 TO 3
                    IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
                NEXT SI
            END IF
            IF SEC$(I, J) = "C" THEN
                commanders = commanders - 1
                FOR SI = 1 TO 20
                    IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
                NEXT SI
            END IF
            IF SEC$(I, J) = "K" THEN
                KLINGS = KLINGS - 1
                IF KLINGS < 1 THEN KLINGS = 0
                HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                GAL$(SX, SY) = HGAL$(SX, SY)
            END IF
            IF SEC$(I, J) = "R" THEN ROMULANS = ROMULANS - 1
            SEC$(I, J) = "."
            CALL SECDRAW
            GOTO KATTENDJ
        END IF
        DIST = SQR((EX - I) ^ 2 + (EY - J) ^ 2)
        EPHAS = STRENGTH(I, J) / (2 * DIST)
        IF SHIELDS = 1 THEN SHENERGY = SHENERGY - EPHAS
        COLOR RED, BACKGROUND
        PRINT EPHAS; " unit Phasor hit from ";
        IF SEC$(I, J) = "R" THEN PRINT "Romulan ";
        IF SEC$(I, J) = "K" THEN PRINT MENEMIES$; " ";
        IF SEC$(I, J) = "C" THEN PRINT MENEMIES$; " Commander ";
        IF SEC$(I, J) = "S" THEN PRINT MENEMIES$; " Super Commander ";
        PRINT "at sector "; I; ","; J
        IF SHENERGY < 0 THEN SHIELDS = 0: SHENERGY = 0
        COLOR RED, BACKGROUND
        IF RND > SHIELDS * SPERCENT THEN
            PRINT "Computer Damaged ";
            DLEN(6) = DLEN(6) + RND * (EPHAS / 1000)
            computer = 0
            GOTO KATTENDJ
        END IF
        IF RND > SHIELDS * SPERCENT THEN
            PRINT "Phasors damaged. ";
            DLEN(3) = DLEN(3) + RND * (EPHAS / 1000)
            PHASORS = 0
            GOTO KATTENDJ
        END IF
        IF RND > SHIELDS * SPERCENT THEN
            PRINT "Photon torpedoe tubes damaged.";
            DLEN(4) = DLEN(4) + RND * (EPHAS / 1000)
            TORPEDOES = -1 * ABS(TORPEDOES)
            GOTO KATTENDJ
        END IF
        IF RND > 10 * SHIELDS * SPERCENT THEN
            PRINT "All weapons damaged.";
            DLEN(4) = DLEN(4) + RND * (EPHAS / 1000)
            DLEN(3) = DLEN(3) + RND * (EPHAS / 1000)
            PHASORS = 0
            GOTO KATTENDJ
        END IF
        IF RND > SHIELDS * SPERCENT THEN
            PRINT "Shields damaged ";
            DLEN(2) = DLEN(2) + RND * (EPHAS / 1000)
            SHIELDS = -1 * ABS(SHIELDS)
            GOTO KATTENDJ
        END IF
        IF RND > 10 * SHIELDS * SPERCENT THEN
            PRINT "Life support damaged ";
            life = 0
            DLEN(7) = DLEN(7) + RND * (EPHAS / 1000)
            GOTO KATTENDJ
        END IF
        IF RND > 20 * SHIELDS * SPERCENT THEN
            PRINT "Crystals deterioriating ";
            CRYSTALS = 0
            DLEN(8) = DLEN(8) + RND * (EPHAS / 1000)
            GOTO KATTENDJ
        END IF
        IF KLINGS <> 0 THEN CONDITION = 3

        KATTENDJ: COLOR BLUE, BACKGROUND
    NEXT J
NEXT I
CALL MAKEDISPLAY
END SUB

SUB LRSCAN
'
' Here we perform a long range scan and update the galaxy map
'
SHARED SX, SY, GAL$(), HGAL$(), BACKGROUND
FOR I = SX - 1 TO SX + 1
    FOR J = SY - 1 TO SY + 1
        IF I <= 0 OR I > 9 OR J <= 0 OR J > 9 THEN GOTO ESCAN
        GAL$(I, J) = RIGHT$(HGAL$(I, J), 3)
    ESCAN: NEXT J
NEXT I
CALL GALDRAW
END SUB

SUB MAKEDISPLAY STATIC
'
'This subroutine sets up the bridge display. The display
'contains the sector and explored galaxy maps as well as
'the system status information. It assumes an CGA display.
'
SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
SHARED TRANSPORTER, SX, SY, SHIP$, CLOAK, computer
SHARED Klingons, commanders, SUPERS, BACKGROUND, MENEMIES$
IF CONDITION < 0 AND SHIP$ = "U.S.S. ENTERPRISE" THEN
    ENERGY = 20000
    TORPEDOES = 20
    CRYSTALS = 1
    SHENERGY = 10000
END IF
IF CONDITION < 0 AND SHIP$ = "U.S.S. QUAHOG" THEN
    ENERGY = 10000
    TORPEDOES = 10
    CRYSTALS = 1
    SHENERGY = 5000
END IF
CALL SECDRAW
CALL GALDRAW
CRM = CSRLIN: CCM = POS(0)
VIEW PRINT 1 TO 24
LOCATE 14, 1
PRINT "Ship Status , "; SHIP$; "               ";
COLOR BLUE, BACKGROUND: PRINT "STARDATE : ";: COLOR BLACK, BACKGROUND: PRINT SDATE: PRINT
COLOR BLUE, BACKGROUND: PRINT "ENERGY : ";: COLOR BLACK, BACKGROUND: PRINT ENERGY; "   "
COLOR BLUE, BACKGROUND: PRINT "DRIVE : ";
IF drive = 2 THEN COLOR BLACK, BACKGROUND: PRINT "  WARP  "
IF drive = 1 THEN COLOR ORANGE, BACKGROUND: PRINT " IMPULSE"
IF drive = 0 THEN COLOR FRED, BACKGROUND: PRINT " NONE   "
COLOR BLUE, BACKGROUND: PRINT "SPEED : ";
IF SPEED < 7.5 THEN COLOR BLACK, BACKGROUND: PRINT " WARP "; SPEED ELSE COLOR FRED, BACKGROUND: PRINT " WARP "; SPEED
COLOR BLUE, BACKGROUND: PRINT "LIFE SUPPORT : ";
IF life = 1 THEN COLOR GREEN, BACKGROUND: PRINT "ACTIVE"
IF life = 0 THEN COLOR FRED, BACKGROUND: PRINT "FAILED"
COLOR BLUE, BACKGROUND: PRINT "CLOAK : ";
IF CLOAK = 0 THEN COLOR ORANGE, BACKGROUND: PRINT "DOWN  " ELSE COLOR GREEN, BACKGROUND: PRINT "ACTIVE"
LOCATE 19, 25
COLOR BLUE, BACKGROUND: PRINT "SHIELDS : ";
IF SHIP$ = "U.S.S. QUAHOG" THEN SPERCENT = INT(SHENERGY / 10) / 5
IF SHIP$ = "U.S.S. ENTERPRISE" THEN SPERCENT = INT(SHENERGY / 10) / 10
IF SHIELDS = 0 THEN COLOR BLACK, BACKGROUND: PRINT "DOWN   "; SPERCENT; " %  ";
IF SHIELDS = 1 THEN COLOR RED, BACKGROUND: PRINT "UP     "; SPERCENT; " %  ";
IF SHIELDS < 0 THEN COLOR FRED, BACKGROUND: PRINT "DAMAGED";
LOCATE 16, 25
IF ENEMY = 0 AND CONDITION = 3 THEN CONDITION = 1
COLOR BLUE, BACKGROUND: PRINT "CONDITION : ";
IF CONDITION < 0 THEN COLOR GREEN, BACKGROUND: PRINT "DOCKED"
IF CONDITION = 1 THEN COLOR GREEN, BACKGROUND: PRINT "GREEN "
IF CONDITION = 2 THEN COLOR ORANGE, BACKGROUND: PRINT "YELLOW"
IF CONDITION = 3 THEN COLOR FRED, BACKGROUND: PRINT "RED   "
LOCATE 17, 25
COLOR BLUE, BACKGROUND: PRINT "CRYSTALS : ";:
IF CRYSTALS = 1 THEN COLOR GREEN, BACKGROUND: PRINT "STABLE  "
IF CRYSTALS = 0 THEN COLOR FRED, BACKGROUND: PRINT "UNSTABLE"
LOCATE 18, 25
COLOR BLUE, BACKGROUND: PRINT "SHIELD ENERGY : ";: COLOR BLACK, BACKGROUND: PRINT SHENERGY; "    "
LOCATE 20, 25
COLOR BLUE, BACKGROUND: PRINT "COMPUTER : ";
IF computer = 1 THEN COLOR GREEN, BACKGROUND: PRINT "FUNCTIONAL"; ELSE COLOR RED, BACKGROUND: PRINT "DAMAGED   ";
LOCATE 16, 55
COLOR BLUE, BACKGROUND: PRINT "PHASORS : ";
IF PHASORS = 1 THEN COLOR GREEN, BACKGROUND: PRINT "OPERATIONAL" ELSE COLOR FRED, BACKGROUND: PRINT "DAMAGED    "
LOCATE 17, 55
COLOR BLUE, BACKGROUND: PRINT "PHOTON "
LOCATE 18, 55: PRINT "TORPEDOES : ";
IF TORPEDOES < 0 THEN COLOR FRED, BACKGROUND: PRINT "TUBES DAMAGED";
IF TORPEDOES = 0 THEN COLOR RED, BACKGROUND: PRINT TORPEDOES; "          ";
IF TORPEDOES > 0 THEN COLOR BLACK, BACKGROUND: PRINT TORPEDOES; "          ";
LOCATE 19, 55
COLOR BLUE, BACKGROUND: PRINT "TRANSPORTER : ";
IF TRANSPORTER = 1 THEN COLOR GREEN, BACKGROUND: PRINT "OPERATIONAL" ELSE COLOR RED, BACKGROUND: PRINT "DAMAGED   "
LOCATE 20, 55
COLOR BLUE, BACKGROUND: PRINT MENEMIES$; "s LEFT : "; Klingons + commanders + SUPERS
VIEW PRINT 21 TO 24
IF CRM < 21 THEN CRM = 24: CCM = 1
LOCATE CRM, CCM
END SUB

SUB REPAIRSTATUS
'
'       This routine informs the Captain of device repair status
'
SHARED DLEN(), BACKGROUND
TIMER OFF
VIEW PRINT 1 TO 24
CLS
COLOR RED, BACKGROUND
PRINT "DEVICE           REPAIR TIMES:     UNDOCKED        DOCKED"
PRINT
COLOR ORANGE, BACKGROUND
PRINT USING "WARP DRIVE                         ####.##        ####.##"; DLEN(1); DLEN(1) / 20
COLOR ORANGE, BACKGROUND
PRINT USING "SHIELDS                            ####.##        ####.##"; DLEN(2); DLEN(2) / 20
COLOR ORANGE, BACKGROUND
PRINT USING "PHASORS                            ####.##        ####.##"; DLEN(3); DLEN(3) / 20
COLOR ORANGE, BACKGROUND
PRINT USING "PHOTON TORPEDOE TUBES              ####.##        ####.##"; DLEN(4); DLEN(4) / 20
COLOR ORANGE, BACKGROUND
PRINT USING "CLOAKING DEVICE                    ####.##        ####.##"; DLEN(5); DLEN(5) / 20
COLOR ORANGE, BACKGROUND
PRINT USING "COMPUTER                           ####.##        ####.##"; DLEN(6); DLEN(6) / 20
COLOR ORANGE, BACKGROUND
PRINT USING "LIFE SUPPORT SYSTEMS               ####.##        ####.##"; DLEN(7); DLEN(7) / 20
COLOR ORANGE, BACKGROUND
PRINT USING "DILITHIUM CRYSTALS                 ####.##        ####.##"; DLEN(8); DLEN(8) / 20
PRINT
COLOR BLUE, BACKGROUND
PRINT: PRINT "Hit any key to return to game..."
rep: A$ = INKEY$: IF A$ = "" THEN GOTO rep
CLS
LOCATE 24, 1
CALL MAKEDISPLAY
TIMER ON
END SUB

SUB SECDRAW STATIC
'
' This subroutine redraws the whole sector
'
SHARED SX, SY, EX, EY, STRENGTH(), CONDITION, BACKGROUND, MENEMIES$
TIMER OFF
IF EX < 1 THEN EX = 1
IF EX > 9 THEN EX = 9
IF EY < 1 THEN EY = 1
IF EY > 9 THEN EY = 9
IF SHIP$ = "U.S.S. ENTERPRISE" THEN
    SEC$(EX, EY) = "E"
ELSE
    SEC$(EX, EY) = "Q"
END IF
CRS = CSRLIN
CCS = POS(0)
WIDTH 80, 25
VIEW PRINT 1 TO 24
COLOR BLUE, BACKGROUND
LOCATE 1, 52
PRINT "  Sector"; SX; ","; SY; " Map"
LOCATE 3, 48
PRINT "  1  2  3  4  5  6  7  8  9"
FOR I = 1 TO 9
    COLOR BLUE, BACKGROUND
    LOCATE 3 + I, 46
    PRINT STR$(I);: COLOR BLACK, BACKGROUND
    FOR J = 1 TO 9
        COLOR BLACK, BACKGROUND
        IF SEC$(J, I) = CHR$(15) THEN COLOR ORANGE, BACKGROUND
        IF SEC$(J, I) = CHR$(21) THEN COLOR PURPLE, BACKGROUND
        IF SEC$(J, I) = "K" THEN COLOR ORANGE, BACKGROUND
        IF SEC$(J, I) = "S" THEN COLOR FRED, BACKGROUND
        IF SEC$(J, I) = "C" THEN COLOR RED, BACKGROUND
        IF SEC$(J, I) = "P" THEN COLOR GREEN, BACKGROUND
        IF SEC$(J, I) = "E" THEN COLOR FBLUE, BACKGROUND
        IF SEC$(J, I) = "Q" THEN COLOR FBLUE, BACKGROUND
        IF SEC$(J, I) = "B" THEN COLOR BLUE, BACKGROUND
        IF SEC$(J, I) = "*" THEN COLOR PURPLE, BACKGROUND
        IF SEC$(J, I) = "R" THEN
            IF STRENGTH(J, I) > 1500 THEN
                PRINT "  .";
                GOTO SECENDJ
            END IF
            COLOR ORANGE, BACKGROUND
        END IF
        IF MENEMIES$ <> "Klingon" AND SEC$(J, I) = "K" THEN
            PRINT "  "; LEFT$(MENEMIES$, 1);
        ELSE
            PRINT "  "; SEC$(J, I);
        END IF
        COLOR BLACK, BACKGROUND
    SECENDJ: NEXT J
    COLOR BLUE, BACKGROUND: PRINT " "; STR$(I)
NEXT I
VIEW PRINT 21 TO 24
IF CRS < 21 THEN CRS = 24: CCS = 1
LOCATE CRS, CCS
IF CONDITION >= 0 THEN TIMER ON
END SUB

SUB SENERGY
'
' This subroutine allows one to change the energy of the shields
'
SHARED C$, SHIELDS, SHENERGY, ENERGY, BACKGROUND
IF SHIELDS < 0 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'Shields are damaged, Captain.'"
    EXIT SUB
END IF
C$ = RIGHT$(C$, LEN(C$) - 2)
IF LEN(C$) = 0 THEN
    COLOR RED, BACKGROUND
    PRINT WOFFICER$; " asks, 'By how much to we change the shield energy ";
    INPUT SHCHANGE
ELSE
    SHCHANGE = VAL(C$)
END IF
IF SHCHANGE > ENERGY THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " says, 'But Captain, we need a wee bit more energy to do that !'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF SHCHANGE < 0 AND ABS(SHCHANGE) >= SHENERGY THEN
    ENERGY = ENERGY + SHENERGY - 100
    SHENERGY = 0
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'All energy drained from shields.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF SHCHANGE > 10000 - SHENERGY THEN SHCHANGE = 10000 - SHENERGY
IF SHCHANGE < 0 AND ABS(SHCHANGE) > 20000 - ENERGY THEN SHCHANGE = ENERGY - 20000
IF SHCHANGE < 0 AND ABS(SHCHANGE) <= SHENERGY THEN
    ENERGY = ENERGY - SHCHANGE - 100
    SHENERGY = SHENERGY + SHCHANGE
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, ' "; ABS(SHCHANGE); " energy units drained from shields.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF SHCHANGE > 0 AND SHCHANGE + 100 <= ENERGY THEN
    ENERGY = ENERGY - SHCHANGE - 100
    SHENERGY = SHENERGY + SHCHANGE
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports,' "; SHCHANGE; " energy units diverted to shields.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF

END SUB

SUB SHIELD
'
' This routine raises or lowerers the shields
'
SHARED BACKGROUND
IF SHIELDS = 1 OR SHIELDS = 0 THEN ENERGY = ENERGY - 100
IF ENERGY <= 0 THEN ENERGY = 0: COLOR RED, BACKGROUND: PRINT "NO ENERGY": CALL MAKEDISPLAY: EXIT SUB
IF SHIELDS = 0 THEN SHIELDS = 1: CALL MAKEDISPLAY: EXIT SUB
IF SHIELDS = 1 THEN SHIELDS = 0: CALL MAKEDISPLAY: EXIT SUB
IF SHIELDS < 0 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'Shields are damaged, Captain.'"
    EXIT SUB
END IF
END SUB

SUB SWAIT
'
'       This allows the passage of Star Time
'
SHARED SDATE, ODATE, BACKGROUND
COLOR RED, BACKGROUND
PRINT "How long to wait ";: INPUT W
IF W <= 0 THEN EXIT SUB
ODATE = SDATE
SDATE = SDATE + W
END SUB

'
'       This module is part of TREK written by Burns Lab
'       University of Florida
'       Physics Department
'
'       BETA TEST VERSION 3.0   LAST UPDATED 5-JAN-91
'


SUB COMSCREEN
'
'       This routine gives details on how to use the commands.
'
SHARED BACKGROUND
TIMER OFF
VIEW PRINT 1 TO 24
CLS
COLOR RED, BACKGROUND
PRINT "COMMAND SYNTAX:"
PRINT
COLOR BLUE, BACKGROUND
PRINT "The characters typed in ";
IF BACKGROUND = 7 THEN
    COLOR RED, BACKGROUND
    PRINT "RED ";
ELSE
    PRINT "CAPITALS ";
END IF
COLOR BLUE, BACKGROUND: PRINT " are those used to execute these commands."
PRINT
COLOR RED, BACKGROUND:
PRINT " ABANDON";: COLOR BLUE, BACKGROUND: PRINT "          ship is abandoned."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "TO RAISE OR LOWER CLOAKING DEVICE :"
COLOR RED, BACKGROUND
PRINT " CL";: COLOR BLUE, BACKGROUND: PRINT "                     This command changes the Cloaking Device"
PRINT "                        If up ---> change to down."
PRINT "                        If down ---> change to up."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "To dock/undock at a Star Base :"
COLOR RED, BACKGROUND
PRINT " D";: COLOR BLUE, BACKGROUND: PRINT "                energy, torpedoes replenished. Repairs can be made."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "To temporarily hide from your co-workers and boss that you are"
PRINT "diddiling around with this game rather than working:"
COLOR RED, BACKGROUND
PRINT " F";: COLOR BLUE, BACKGROUND: PRINT "                 Flips a fake Lotus 123-looking screen up."
PRINT "                 Hitting the TAB key brings the game back."
PRINT "                 Hitting % silently kills the game and "
PRINT "                 prints a fake error message. Hitting / runs a DOS"
PRINT "                 shell."
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC1END: A$ = INKEY$: IF A$ = "" THEN GOTO SC1END
CLS
COLOR ORANGE, BACKGROUND
PRINT "For rescue by a Star Base :"
COLOR RED, BACKGROUND
PRINT " HELP";: COLOR BLUE, BACKGROUND: PRINT "             The nearest Star Base will make"
PRINT "                  three attempts at using the experimental"
PRINT "                  galactic transporter beam to transport"
PRINT "                  the ship to safty."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "To perform a long range scan :"
COLOR RED, BACKGROUND
PRINT " L";: COLOR BLUE, BACKGROUND: PRINT "        long range sensors can detect regular "; MENEMIES$
PRINT "          and stars in adjacent quadrants. The various cloaking"
PRINT "          devices of "; MENEMIES$; " Commanders (";: COLOR RED, BACKGROUND: PRINT "C";: COLOR BLUE, BACKGROUND: PRINT "), "; MENEMIES$; " Super Commanders (";: COLOR FRED, BACKGROUND: PRINT "S";: COLOR BLUE, BACKGROUND: PRINT "),"
PRINT "          Romulans (";: COLOR ORANGE, BACKGROUND: PRINT "R";: COLOR BLUE, BACKGROUND: PRINT ") and the "; benemies$; " machines (";: COLOR PURPLE, BACKGROUND: PRINT CHR$(21);: COLOR BLUE, BACKGROUND: PRINT ") allow them"
PRINT "          to escape detection except possibly at close range. ";: COLOR PURPLE, BACKGROUND: PRINT "Romulans"
PRINT "         can very often escape detection even at short range if they"
PRINT "         have sufficient energy. In this case, they will appear to be"
PRINT "         invisible until they are too weak to power their cloaking devices."
PRINT: COLOR BLUE, BACKGROUND
PRINT "    The map of the explored galaxy quadrants is read as"
PRINT "         #Regular "; MENEMIES$; "s, Base, #Stars"
PRINT
PRINT "    For example  803 means 8 regular "; MENEMIES$; "s, no Star Bases and 3 stars."
PRINT "                 2B6 means 2 regular "; MENEMIES$; ", a Star Base and 6 stars."; ""
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC2END: A$ = INKEY$: IF A$ = "" THEN GOTO SC2END
CLS
COLOR ORANGE, BACKGROUND
PRINT "TO MOVE SHIP - manually :"
COLOR RED, BACKGROUND
PRINT " M M x y ";: COLOR BLUE, BACKGROUND: PRINT "         displaces ship by x & y sectors within the quadrant"
COLOR RED, BACKGROUND
PRINT " M M qx qy x y ";: COLOR BLUE, BACKGROUND: PRINT "   displaces ship by qx & qy quadants within the galaxy"
PRINT "                  and by x & y sectors relative to its current position."
COLOR ORANGE, BACKGROUND: PRINT "             - automatically :"
COLOR RED, BACKGROUND
PRINT " M A x y ";: COLOR BLUE, BACKGROUND: PRINT "         automatically moves ship to sector x,y within the quadrant"
COLOR RED, BACKGROUND
PRINT " M A qx qy x y ";: COLOR BLUE, BACKGROUND: PRINT "   automatically moves ship to quadrant qx,qy within the galaxy"
PRINT "                  and to sector x,y within quadant qx,qy"
PRINT
PRINT
PRINT "             qx,qy,x & y ARE IN THE RANGE OF -9 TO 9"
PRINT
COLOR FRED, BACKGROUND: PRINT "          ALL MOVE COMMANDS MUST FOLLOW THE ABOVE SYNTAX"
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC3END: A$ = INKEY$: IF A$ = "" THEN GOTO SC3END
CLS
COLOR ORANGE, BACKGROUND
PRINT "TO FIRE PHASORS - automatically :"
COLOR RED, BACKGROUND
PRINT " P A n";: COLOR BLUE, BACKGROUND: PRINT "                  n is the number energy units the fire"
PRINT "                        control computer is allowed to use. The computer"
PRINT "                        evaluates each threat in the quadrant and targets "
PRINT "                        the energy for maximum kills against the largest"
PRINT "                        threats. If n is omitted, n = 1000 or half of the ships"
PRINT "                        energy, whichever is less."
COLOR ORANGE, BACKGROUND
PRINT "                - manually :"
COLOR RED, BACKGROUND
PRINT " P M";: COLOR BLUE, BACKGROUND: PRINT "                    The fire control computer performs a threat"
PRINT "                        analysis and asks how much energy you wish to"
PRINT "                        direct against each target. It will inform you of"
PRINT "                        its analysis of each target."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "TO QUIT THE GAME :"
COLOR RED, BACKGROUND
PRINT " QUIT";: COLOR BLUE, BACKGROUND: PRINT "                 Ends the game and gives you the score."
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC4END: A$ = INKEY$: IF A$ = "" THEN GOTO SC4END
CLS
COLOR ORANGE, BACKGROUND
PRINT "TO FIND THE LENGTHS OF EQUIPMENT REPAIRS :"
COLOR RED, BACKGROUND
PRINT " RS";: COLOR BLUE, BACKGROUND: PRINT "                    produces a listing of all damagable"
PRINT "                       equipment on board and the in flight repair times"
PRINT "                       and Star Base docked repair times. Use the"
PRINT "                       ";: COLOR RED, BACKGROUND: PRINT "W";: COLOR BLUE, BACKGROUND: PRINT " command to effect repairs"
PRINT "                       or allow them to be repaired as you travel."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "TO PERFORM A SHORT RANGE SCAN :"
COLOR RED, BACKGROUND
PRINT " S    ";: COLOR BLUE, BACKGROUND: PRINT "           This command gives a short-range "
PRINT "                 scan report about the current sector. Report includes"
PRINT "                 information about planets and their resources, detectable"
PRINT "                 enemies, stars and bases. Planets which contain crystals"
PRINT "                 can be mined and the crystals used to reenergise the ship."
PRINT "                 Fully cloaked Romulans will not be seen on-screen or by "
PRINT "                 these sensors."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "TO CHANGE SHIELD ENERGY :"
COLOR RED, BACKGROUND
PRINT " SE n";: COLOR BLUE, BACKGROUND: PRINT "                   n is the number of energy units to raise shields."
PRINT "                        If n>0 then shield energy is increased (10000 unit max)"
PRINT "                        If n<0 then shield energy is lowered."
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC5END: A$ = INKEY$: IF A$ = "" THEN GOTO SC5END
CLS
COLOR ORANGE, BACKGROUND
PRINT "TO RAISE OR LOWER SHIELDS :"
COLOR RED, BACKGROUND
PRINT " SH";: COLOR BLUE, BACKGROUND: PRINT "                     This command changes the shields"
PRINT "                        If up ---> change to down."
PRINT "                        If down ---> change to up."
PRINT
COLOR ORANGE, BACKGROUND
PRINT "TO FIRE PHOTON TORPEDOES (up to 3) :"
COLOR RED, BACKGROUND
PRINT " T n x1 y1 x2 y2 x3 y3 ";: COLOR BLUE, BACKGROUND: PRINT " n is the number of torpedoes (1,2 or 3)."
PRINT "                        xi yi are the target coordinates for each torpedoe."
PRINT "                        "
PRINT "                        At least one target coordinate pair must be specified."
PRINT "                        If more torpedoes than target coordinates are"
PRINT "                        specified, the ships computer will assume multiple"
PRINT "                        torpedoes go to the last coordinate pair. "
PRINT "                        For Example:"
PRINT "                                 T 3 5 5 will be treated as T 3 5 5 5 5 5 5"
PRINT "                                 T 3 2 3 1 3 wil be treated as T 3 2 3 1 3 1 3"
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC6END: A$ = INKEY$: IF A$ = "" THEN GOTO SC6END
CLS
COLOR ORANGE, BACKGROUND
PRINT "TO TRANSPORT TO AND FROM A PLANET :"
COLOR RED, BACKGROUND
PRINT " TR  ";: COLOR BLUE, BACKGROUND: PRINT "            This beams a landing party up or"
PRINT "                 down from a planet surface. If the planet contains dilithium"
PRINT "                 crystals, then they will be mined. Shields must be down to"
PRINT "                 beam up or down and you cannot leave the landing"
PRINT "                 party stranded."
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC7END: A$ = INKEY$: IF A$ = "" THEN GOTO SC7END
CLS
COLOR ORANGE, BACKGROUND
PRINT "TO SET SHIP SPEED :"
COLOR RED, BACKGROUND
PRINT " W n";: COLOR BLUE, BACKGROUND: PRINT "             This command sets the ships speed to warp n."
PRINT "                 If n is omitted or illegal, you will be prompted."
PRINT "                 This value can be from warp 0 to warp 10."
PRINT "                 Running at speeds in excess of warp 8 is dangerous -"
PRINT "                 the dual warp pods lose coherence causing possible"
PRINT "                 time warping instead of pure space warping. Above"
PRINT "                 warp 8 but below warp 9.8, the ship will sometimes"
PRINT "                 warp correctly and sometimes timewarp. The larger "
PRINT "                 the warp setting the more likly a time warp will occur."
PRINT "                 Above warp 9.8 the warp drive is purely time warping."
PRINT "                 This means you change temporal location but don't move"
PRINT "                 spacially. "
COLOR RED, BACKGROUND
PRINT "                 If you end up having gone backward through time,"
PRINT "                 you may find the enemies you killed alive again!"
PRINT "                 Don't bet on timewarping forward to find you enemies"
PRINT "                 dead of old age. Timewarps also have a nasty habit of"
PRINT "                 draining the antimatter reactors."
COLOR BLUE, BACKGROUND
PRINT "                 Warp settings of less than 1 run the impulse engines."
PRINT "                 Use this mode ( WARP <= 1 ) when Warp Drive is damaged."
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO SEE MORE COMMANDS...";
SC8END: A$ = INKEY$: IF A$ = "" THEN GOTO SC8END
CLS
COLOR ORANGE, BACKGROUND
PRINT "TO WAIT WHILE REPAIRS ARE UNDERWAY :"
COLOR RED, BACKGROUND
PRINT " WA  ";: COLOR BLUE, BACKGROUND: PRINT "                          Will ask for the number of Star Dates to wait."
PRINT
COLOR RED, BACKGROUND: PRINT: PRINT "HIT ANY KEY TO RETURN TO GAME..."
SCEEND: A$ = INKEY$: IF A$ = "" THEN GOTO SCEEND
CLS
LOCATE 24, 1
CALL MAKEDISPLAY
TIMER ON
END SUB

SUB DELAY (X) STATIC
'
'       THIS ROUTINE DELAYS FOR X SECONDS. THE RESOLUTION
'       OF THE TIME DELAY IS 0.05 SECONDS. MAXIMUM DELAY WOULD
'       48 HOURS-0.01 SECONDS, BUT ONLY IF THE DELAY WAS STARTED
'       AT MIDNIGHT. FOR ARBITRARY STARTING TIME, THE MAX DELAY
'       IS 24 HOURS.
'
TIMER OFF
DELAYEND = X + TIMER
IF DELAYEND < 86400 THEN
    ODATE$ = " "
    GOTO DELAYLOOP
END IF
ODATE$ = DATE$
DREMAINDER = DELAYEND - INT(DELAYEND)
DELAYEND = INT(DELAYEND) / 86400
DELAYEND = DELAYEND - INT(DELAYEND)
DELAYEND = DELAYEND * 86400 + DREMAINDER
DELAYLOOP: IF DELAYEND > TIMER OR ODATE$ = DATE$ THEN GOTO DELAYLOOP
TIMER ON
END SUB

SUB PTORPEDOES
'
' We now target, fire and track the photon torpedoes
'
SHARED SX, SY, SHIP$, EX, EY, BEZI(), BEZJ(), BEZA()
SHARED ROMULANS, commanders, SUPERS, BERZERKS, PLANETS, BASES
SHARED KLINGS, ENEMY, Klingons
SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life
SHARED TRANSPORTER, C$, computer, BACKGROUND
SHARED SEC$(), STRENGTH(), ROMI(), ROMJ()
DIM SLOPE(3), OX%(3), OY%(3), TRAJECTORY(3), II(3), EXIST(3)
DIM INDEX(3), INDEY(3), IX(3), IY(3), TX(3), TY(3)
'ON ERROR GOTO ERRMESSAGE
ON ERROR GOTO 0
IF TORPEDOES < 0 THEN
    COLOR RED, BACKGROUND
    PRINT "Fire Control reporting, Sir. The Photon Tubes won't fire."
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF TORPEDOES = 0 THEN
    COLOR RED, BACKGROUND
    PRINT "Fire Control reporting, Sir. No Photons left down here."
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF computer = 0 THEN
    COLOR RED, BACKGROUND
    PRINT WOFFICER$; " reports, 'The Photon tubes cannot be aimed with a damaged computer.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
FOR I = 1 TO 9
    FOR J = 1 TO 9
        IF SEC$(I, J) = "K" OR SEC$(I, J) = "S" OR SEC$(I, J) = "C" OR SEC$(I, J) = "R" THEN
            IF STRENGTH(I, J) <= 0 THEN
                COLOR RED, BACKGROUND
                PRINT WOFFICER$; " reports, 'Enemy ";
                PRINT " at "; I; ","; J; " just exploded, Sir.'"
                IF WOFFICER$ = "Chekov" THEN PRINT "wessel"; ELSE PRINT "vessel";
                COLOR BLUE, BACKGROUND
                IF SEC$(I, J) = "R" OR SEC$(I, J) = "." THEN
                    ROMULANS = ROMULANS - 1
                    SEC$(I, J) = "."
                    STRENGTH(I, J) = 1000000!
                    GOTO FREDJ
                END IF
                Klingons = Klingons - 1
                ENEMY = ENEMY - 1
                STRENGTH(I, J) = 1000000!
                IF SEC$(I, J) = "K" THEN
                    KLINGS = KLINGS - 1
                    IF KLINGS < 1 THEN KLINGS = 0
                    HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
                    HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
                    GAL$(SX, SY) = HGAL$(SX, SY)
                END IF
                SEC$(I, J) = "."
                CALL SECDRAW
            END IF
        END IF
    FREDJ: NEXT J
NEXT I

TSTART: FOR J = 1 TO 3
    EXIST(J) = 0
    OX%(J) = 0: OY%(J) = 0
NEXT J
I = LEN(C$) - 2
C$ = RIGHT$(C$, I)
C$ = LTRIM$(C$)
NUM = VAL(LEFT$(C$, 2))
IF NUM > TORPEDOES THEN
    COLOR RED, BACKGROUND
    PRINT "Fire Control reporting, Sir. FIRING ALL REMAINING TORPEDOES."
    COLOR BLUE, BACKGROUND
    NUM = TORPEDOES
END IF
ECLOAK = 0
TORPEDOES = TORPEDOES - NUM
I = INSTR(C$, " ")
J = LEN(C$)
C$ = RIGHT$(C$, J - I)
C$ = LTRIM$(C$)
IF LEN(C$) < 3 THEN
    TORPEDOES = TORPEDOES + 1
    COLOR RED, BACKGROUND
    PRINT "Fire Control Reporting, Sir. We did'nt understand that last command."
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF NUM = 3 AND LEN(C$) = 7 THEN C$ = C$ + RIGHT$(C$, 4)
IF NUM = 3 AND LEN(C$) = 3 THEN C$ = C$ + " " + C$ + " " + C$
IF NUM = 2 AND LEN(C$) = 3 THEN C$ = C$ + " " + C$
FOR J = 1 TO NUM
    TX(J) = VAL(LEFT$(C$, 2))
    I = LEN(C$)
    C$ = RIGHT$(C$, I - 2)
    TY(J) = VAL(LEFT$(C$, 2))
    IF RND < .1 THEN
        IF RND > .5 THEN TX(J) = TX(J) + 1
        IF RND > .5 THEN TX(J) = TX(J) - 1
        IF RND > .5 THEN TY(J) = TY(J) + 1
        IF RND > .5 THEN TY(J) = TY(J) - 1
        COLOR RED, BACKGROUND
        PRINT "Fire Control reporting, Sir. WE ARE HAVING AIMING PROBLEMS."
        COLOR BLUE, BACKGROUND
        IF TX(J) > 9 THEN TX(J) = 9
        IF TX(J) < 1 THEN TX(J) = 1
        IF TY(J) > 9 THEN TY(J) = 9
        IF TX(J) < 1 THEN TX(J) = 1
    END IF
    IF J < NUM THEN C$ = RIGHT$(C$, LEN(C$) - 2)
    INDEX(J) = 1: IF TX(J) < EX THEN INDEX(J) = -1
    INDEY(J) = 1: IF TY(J) < EY THEN INDEY(J) = -1
    IX(J) = TX(J) - EX: IY(J) = TY(J) - EY
    IF IX(J) <> 0 THEN SLOPE(J) = IY(J) / IX(J)
    OX%(J) = EX: OY%(J) = EY
    EXIST(J) = 1: II(J) = EX
    TRAJECTORY(J) = EY
NEXT J
TRAG: FOR J = 1 TO NUM
    IF EXIST(J) = 0 THEN GOTO ENDTII
    II(J) = II(J) + INDEX(J)
    IF IX(J) <> 0 THEN TRAJECTORY(J) = CINT((SLOPE(J) * (II(J) - EX)) + EY)
    IF IX(J) = 0 THEN II(J) = EX: TRAJECTORY(J) = TRAJECTORY(J) + INDEY(J)
    IF II(J) < 1 OR II(J) > 9 THEN COLOR RED, BACKGROUND: PRINT "MISSED ": COLOR BLUE, BACKGROUND: SEC$(OX%(J), OY%(J)) = ".": EXIST(J) = 0: GOTO REALENDJ
    IF TRAJECTORY(J) < 1 OR TRAJECTORY(J) > 9 THEN COLOR RED, BACKGROUND: PRINT "MISSED ": COLOR BLUE, BACKGROUND: SEC$(OX%(J), OY%(J)) = ".": EXIST(J) = 0: GOTO REALENDJ
    IF SEC$(II(J), TRAJECTORY(J)) <> "*" AND SEC$(II(J), TRAJECTORY(J)) <> "." AND (SEC$(II(J), TRAJECTORY(J)) <> "Q" AND SEC$(II(J), TRAJECTORY(J)) <> "E") THEN SEC$(OX%(J), OY%(J)) = ".": EXIST(J) = 0: GOTO TCOLLISION
    SEC$(OX%(J), OY%(J)) = ".": SEC$(II(J), TRAJECTORY(J)) = "*"
    OX%(J) = II(J): OY%(J) = TRAJECTORY(J)
ENDTII: NEXT J
CALL SECDRAW
GOTO REALENDJ
TCOLLISION: COLOR RED, BACKGROUND: ARMOR = 0: EXIST(J) = 0
IF SEC$(II(J), TRAJECTORY(J)) = "K" THEN PRINT MENEMIES$; " ";: ARMOR = 1
IF SEC$(II(J), TRAJECTORY(J)) = "C" THEN
    PRINT MENEMIES$; " Commander ";: ARMOR = 2
    FOR SI = 1 TO 20
        IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
    NEXT SI
END IF
IF SEC$(II(J), TRAJECTORY(J)) = "P" THEN
    PRINT "Planet ";
    PLANETSLOST = PLANETSLOST + 1
    FOR SI = 1 TO 10
        IF PLANI(SI) = SX AND PLANJ(SI) = SY THEN PLANI(SI) = 0: PLANJ(SI) = 0: SI = 4
    NEXT SI
END IF
IF SEC$(II(J), TRAJECTORY(J)) = "B" THEN
    PRINT "Star Base  ";: ARMOR = 0
    BASEDESTROYED = BASEDESTROYED + 1
    BASES = BASES - 1
    HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
    HGAL$(SX, SY) = LEFT$(HGAL$(SX, SY), 1) + "0" + RIGHT$(HGAL$(SX, SY), 1)
    HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
    GAL$(SX, SY) = HGAL$(SX, SY)
END IF
IF SEC$(II(J), TRAJECTORY(J)) = "R" THEN
    PRINT "Romulan ";: ARMOR = 2
    FOR SI = 1 TO 20
        IF ROMI(SI) = SX AND ROMJ(SI) = SY THEN ROMI(SI) = 0: ROMJ(SI) = 0: SI = 4
    NEXT SI
END IF

IF SEC$(II(J), TRAJECTORY(J)) = "S" THEN
    PRINT "Super Commander ";: ARMOR = 5
    FOR SI = 1 TO 3
        IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
    NEXT SI
END IF
IF SEC$(II(J), TRAJECTORY(J)) = CHR$(21) THEN
    ARMOR = 1000
    STRENGTH(II(J), TRAJECTORY(J)) = 10000
    COLOR RED, BACKGROUND
    PRINT SOFFICER$; " reports, 'Captain, the "; benemies$; "'s hull is solid neutronium."
    PRINT "We don't appear to have damaged it, we only seem to annoy it.'"
    FOR LLI = 1 TO BERZERKS
        IF BEZI(LLI) = SX AND BEZJ(LLI) = SY THEN BEZA(LLI) = 1
    NEXT LLI
    X = TIMER + 5
    BTIMER: IF TIMER < X THEN GOTO BTIMER
    PRINT benemies$; " ";
END IF
IF SEC$(II(J), TRAJECTORY(J)) = " " THEN PRINT "Black Hole ";: GOTO NOVA
IF SEC$(II(J), TRAJECTORY(J)) = CHR$(15) THEN PRINT "Star ";: GOTO NOVA
PRINT "at "; STR$(II(J)); ","; STR$(TRAJECTORY(J));
ENDTJ: SEC$(OX%(J), OY%(J)) = "."
IF 5300 * RND > ARMOR * STRENGTH(II(J), TRAJECTORY(J)) OR STRENGTH(II(J), TRAJECTORY(J)) <= 0 THEN
    PRINT " Destroyed.": ENEMY = ENEMY - 1
    IF SEC$(II(J), TRAJECTORY(J)) = "K" OR SEC$(II(J), TRAJECTORY(J)) = "C" OR SEC$(II(J), TRAJECTORY(J)) = "S" THEN KLINGS = KLINGS - 1
    IF SEC$(II(J), TRAJECTORY(J)) = "K" THEN
        HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
        HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
        GAL$(SX, SY) = HGAL$(SX, SY)
        Klingons = Klingons - 1
    END IF
    IF SEC$(II(J), TRAJECTORY(J)) = "C" THEN commanders = commanders - 1
    IF SEC$(II(J), TRAJECTORY(J)) = "S" THEN SUPERS = SUPERS - 1
    IF SEC$(II(J), TRAJECTORY(J)) = "R" THEN ROMULANS = ROMULANS - 1
    SEC$(II(J), TRAJECTORY(J)) = "."
    STRENGTH(II(J), TRAJECTORY(J)) = 1000000!
    GOTO REALENDJ
END IF
IF 5300 * RND > ARMOR * STRENGTH(II(J), TRAJECTORY(J)) THEN
    PRINT " Damaged."
    STRENGTH(II(J), TRAJECTORY(J)) = STRENGTH(II(J), TRAJECTORY(J)) - 1500
    GOTO REALENDJ
END IF
STRENGTH(II(J), TRAJECTORY(J)) = STRENGTH(II(J), TRAJECTORY(J)) - 1000
PRINT " Hit."
REALENDJ: CALL SECDRAW
IF EXIST(1) > 0 OR EXIST(2) > 0 OR EXIST(3) > 0 THEN GOTO TRAG
SEC$(OX%(1), OY%(1)) = ".": SEC$(OX%(2), OY%(2)) = ".": SEC$(OX%(3), OY%(3)) = "."
IF ENEMY < 1 THEN CONDITION = 1
CALL MAKEDISPLAY
PRINT ""
PRINT ""
PRINT ""
PRINT ""
EXIT SUB
NOVA: PRINT "at "; STR$(II(J)); ","; STR$(TRAJECTORY(J));
IF RND > .5 THEN
    PRINT " absorbed torpedo."
    GOTO REALENDJ
END IF
PRINT " triggered into a nova.": SEC$(II(J), TRAJECTORY(J)) = "."
STARS = VAL(RIGHT$(HGAL$(SX, SY), 1)) - 1: IF STARS < 1 THEN STARS = 0
HGAL$(SX, SY) = LEFT$(HGAL$(SX, SY), 2) + LTRIM$(STR$(STARS))
GAL$(SX, SY) = HGAL$(SX, SY)
FOR NI = II(J) - 1 TO II(J) + 1
    FOR NJ = TRAJECTORY(J) - 1 TO TRAJECTORY(J) + 1
        IF NI < 1 OR NI > 9 THEN GOTO ENDNJ
        IF NJ < 1 OR NJ > 9 THEN GOTO ENDNJ
        IF NI = EX AND NJ = EY THEN GOTO THROWENT
        STRENGTH(NI, NJ) = 1000000!
        IF SEC$(NI, NJ) = "." THEN GOTO ENDNJ
        IF SEC$(NI, NJ) = "P" THEN
            PRINT "Planet at "; NI; ","; NJ; " destroyed."
            PLANETSLOST = PLANETSLOST + 1
            FOR SI = 1 TO 10
                IF PLANI(SI) = SX AND PLANJ(SI) = SY THEN PLANI(SI) = 0: PLANJ(SI) = 0: SI = 4
            NEXT SI
        END IF
        IF SEC$(NI, NJ) = "S" THEN
            PRINT "Super Commander at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = ".": SUPERS = SUPERS - 1
            FOR SI = 1 TO 3
                IF SUPI(SI) = SX AND SUPJ(SI) = SY THEN SUPI(SI) = 0: SUPJ(SI) = 0: SI = 4
            NEXT SI
        END IF
        IF SEC$(NI, NJ) = "C" THEN
            PRINT "Commander at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = ".": commanders = commanders - 1
            FOR SI = 1 TO 20
                IF COMI(SI) = SX AND COMJ(SI) = SY THEN COMI(SI) = 0: COMJ(SI) = 0: SI = 21
            NEXT SI
        END IF
        IF SEC$(NI, NJ) = "R" THEN
            PRINT "Romulan at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = "."
            FOR SI = 1 TO 20
                IF ROMI(SI) = SX AND ROMJ(SI) = SY THEN ROMI(SI) = 0: ROMJ(SI) = 0: SI = 4
            NEXT SI
        END IF
        IF SEC$(NI, NJ) = "B" THEN
            SEC$(NI, NJ) = "."
            PRINT "Star Base at "; NI; ","; NJ; "destroyed."
            BASEDESTROYED = BASEDESTROYED + 1
            BASES = BASES - 1
            HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
            HGAL$(SX, SY) = LEFT$(HGAL$(SX, SY), 1) + "0" + RIGHT$(HGAL$(SX, SY), 1)
            HGAL$(SX, SY) = RTRIM$(LTRIM$(HGAL$(SX, SY)))
            GAL$(SX, SY) = HGAL$(SX, SY)
        END IF
        IF SEC$(NI, NJ) = "K" THEN
            PRINT MENEMIES$; " at "; NI; ","; NJ; "destroyed."
            ENEMY = ENEMY - 1: SEC$(NI, NJ) = "."
            Klingons = Klingons - 1: KLINGS = KLINGS - 1
            HGAL$(SX, SY) = STR$(KLINGS) + RIGHT$(HGAL$(SX, SY), 2)
            HGAL$(SX, SY) = LTRIM$(HGAL$(SX, SY))
            GAL$(SX, SY) = HGAL$(SX, SY)
        END IF
        IF SEC$(NI, NJ) = CHR$(21) AND RND > .5 THEN
            PRINT "Berserker at "; NI; ","; NJ; "destroyed.": ENEMY = ENEMY - 1: SEC$(NI, NJ) = "."
            FOR SI = 1 TO 3
                IF BEZI(SI) = SX AND BEZJ(SI) = SY THEN BEZI(SI) = 0: BEZJ(SI) = 0: BEZA(SI) = 0: SI = 4
                KBERZERKERS = KBERZERKERS + 1
            NEXT SI
        END IF
        GOTO ENDNJ
        THROWENT: BEEP: IF RND > .95 * SHIELDS THEN CALL ENDGAME: EXIT SUB
        SEC$(EX, EY) = "."
        NovaLOC: EX = INT(8 * RND + 1): EY = INT(RND * 8 + 1)
        IF SEC$(EX, EY) <> "." THEN GOTO NovaLOC
        DIST = SQR((EX - JJ) ^ 2 + (EY - TRAJECTORYJ) ^ 2) / 10
        ELOSS = (SPEED ^ 3) * DIST * (1 + 1.05 * SHIELDS + .5 * CLOAK)
        ENERGY = ENERGY - ELOSS
        IF ENERGY < 0 THEN ENERGY = 0
        SDATE = SDATE + DIST / (SPEED * SPEED)
        PRINT SHIP$; " thrown by force of nova blast to "; EX; ","; EY; "."
        IF 2 * RND * SPEED > SPEED * SHIELDS THEN
            PRINT "Computer Damaged ";
            DLEN(6) = RND * SPEED
            computer = 0
        END IF
        IF 2 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
            PRINT "All Weapons Damaged ";
            DLEN(4) = RND * SPEED
            DLEN(3) = DLEN(4) * RND
            TORPEDOES = -1 * ABS(TORPEDOES)
            PHASORS = 0
        END IF
        IF 2 * RND * SPEED > SPEED * (.5 + SHIELDS) THEN
            PRINT "Shields Damaged ";
            DLEN(2) = RND * SPEED
            SHIELDS = -1 * ABS(SHIELDS)
        END IF
        IF .5 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
            PRINT "Life support damaged ";
            DLEN(7) = RND * SPEED
            life = 0
        END IF
        IF .1 * RND * SPEED > SPEED * (1 + SHIELDS) THEN
            PRINT "Crystals deterioriating ";
            DLEN(8) = 20 * (1 - RND) / SPEED
            CRYSTALS = 0
        END IF
        IF KLINGS <> 0 THEN CONDITION = 3
        CALL MAKEDISPLAY
    ENDNJ: NEXT NJ
ENDNI: NEXT NI
GOTO REALENDJ
END SUB

SUB TIMEWARP
'
' HERE WE MOVE THE SHIP THROUGH A TIME-WARP AFTER IT FELL
' DOWN A BLACK HOLE OR FROM A WARP ENGINE MALFUNCTION
'
SHARED SX, SY, SHIP$, EX, EY, GAL$(), HGAL$(), OGAL$(), CGAL()
SHARED ROMULANS, commanders, SUPERS, BERZERKS, PLANETS, BASES
SHARED KLINGS, Klingons
SHARED drive, SPEED, ENERGY, CONDITION, CRYSTALS, SHIELDS
SHARED SHENERGY, PHASORS, TORPEDOES, SPERCENT, SDATE, life, ODATE
SHARED TRANSPORTER, C$, computer, IDATE, BACKGROUND
PRINT SOFFICER$; " reports, 'We seem to be in a time-warp, Captain.'"
NDATE = 1.5 * RND * (SDATE - IDATE)
IF RND > .5 THEN
    NDATE = SDATE - NDATE
ELSE
    NDATE = SDATE + NDATE
END IF
IF NDATE < SDATE THEN
    PRINT SOFFICER$; " reports, 'Our Stellar Chronometer is running backwards !'"
    FOR I = 1 TO 9
        FOR J = 1 TO 9
            IF CGAL(I, J) > NDATE THEN
                CKLINGONS = VAL(LEFT$(GAL$(I, J), 1))
                OKLINGONS = VAL(LEFT$(OGAL$(I, J), 1))
                Klingons = Klingons + OKLINGONS - CKLINGONS
                HGAL$(I, J) = OGAL$(I, J)
                GAL$(I, J) = HGAL$(I, J)
                CGAL(I, J) = NDATE
            END IF
        NEXT J
    NEXT I
END IF
IF NDATE > SDATE THEN
    PRINT SOFFICER$; " reports, 'Our Stellar Chronometer is running foward at an incredible rate !'"
END IF
CALL DELAY(10)
PRINT NAVIGATOR$; " says, 'We seemed to have stopped at Stardate "; NDATE; ".'"
PRINT "'We went into the timewarp at Stardate "; SDATE; ".'"
SDATE = NDATE
ODATE = SDATE
CALL MAKEDISPLAY
END SUB

SUB TRANSPORT
'
'       This subroutine transports the crew to a planet suface
'       and mines dilithium crystals if present.
'
SHARED ENERGY, TORPEDOES, SHENERGY, EX, EY, SEC$(), SHIP$, SHIELDS, SX, SY
SHARED PLANETS, TRANSPORTER, TDOWN, SDATE, HEREWEARE, PLANI(), PLANJ(), PLANC()
SHARED BACKGROUND
X = 0
FOR I = EX - 1 TO EX + 1
    FOR J = EY - 1 TO EY + 1
        IF J < 1 OR J > 9 THEN GOTO TDENDJ
        IF I < 1 OR I > 9 THEN GOTO TDENDI
        X = X + INSTR(SEC$(I, J), "P")
    TDENDJ: NEXT J
TDENDI: NEXT I
IF X = 0 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'We are not orbiting a planet, Captian.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF TRANSPORTER <> 1 THEN
    COLOR RED, BACKGROUND
    PRINT ENGINEER$; " reports, 'The transporter is broken, Captian.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF SHIELDS = 1 THEN
    COLOR RED, BACKGROUND
    PRINT NAVIGATOR$; " reports, 'We cannot transport you with raised shields, Captian.'"
    COLOR BLUE, BACKGROUND
    EXIT SUB
END IF
IF TDOWN = 0 THEN
    COLOR RED, BACKGROUND
    PRINT "TRANSPORTING DOWN..."
    COLOR BLUE, BACKGROUND
    TDOWN = 1
    FOR TI = 1 TO PLANETS
        IF PLANI(TI) = SX AND PLANJ(TI) = SY THEN
            IF PLANC(TI) >= 1 THEN
                HEREWEARE = 1
                COLOR RED, BACKGROUND
                PRINT SOFFICER$; " reports, 'Crystals are all over the ground. We will collect some.'"
                COLOR BLUE, BACKGROUND
                PLANC(TI) = PLANC(TI) - 1
                EXIT SUB
            END IF
            IF PLANC(TI) <= 0 THEN
                HEREWEARE = 0
                COLOR RED, BACKGROUND
                X = RND
                IF X > 2 / 3 THEN PRINT NAVIGATOR$; " reports, 'There is nothing but barren wasteland. Similar to New Jersey.'"
                IF X <= 2 / 3 AND X > 1 / 3 THEN
                    IF WOFFICER$ = "Chekov" THEN
                        PRINT "Chekov reports, 'Is fifteen below zero and raining acid.'"
                        PRINT "         'Is much like Siberian beach resort, Captian.'"
                    END IF
                    IF WOFFICER$ <> "Chekov" THEN
                        PRINT WOFFICER$; " reports, 'Nothing here, Captain.'"
                    END IF
                END IF
                IF X <= 1 / 3 THEN
                    PRINT SOFFICER$; " reports, 'There is nothing of interest here. There is only copious"
                    PRINT "         quantities of nude humanoid females with large mammaries."
                    PRINT "         They are quite friendly. They seem to be interested my undergarments.'"
                END IF
                PLANC(TI) = 0
                COLOR BLUE, BACKGROUND
                EXIT SUB
            END IF
        END IF
    NEXT TI
    EXIT SUB
END IF
IF TDOWN = 1 THEN
    COLOR RED, BACKGROUND
    PRINT "TRANSPORTING UP..."
    TDOWN = 0
    COLOR BLUE, BACKGROUND
    IF HEREWEARE = 1 THEN
        COLOR RED, BACKGROUND
        IF SHIP$ = "U.S.S. ENTERPRISE" THEN
            IF ENERGY > 40000 OR TORPEDOES > 40 THEN
                PRINT ENGINEER$; " reports, 'Installing these crystals will destroy the ship!'"
                COLOR BLUE, BACKGROUND
                GOTO DOTRDATE
            END IF
        ELSE
            IF ENERGY > 20000 OR TORPEDOES > 20 THEN
                PRINT ENGINEER$; " reports, 'Installing these crystals will destroy the ship!'"
                COLOR BLUE, BACKGROUND
                GOTO DOTRDATE
            END IF
        END IF
        PRINT ENGINEER$; " reports, 'Crystals installed and adding to ship reserves.'"
        COLOR BLUE, BACKGROUND
        IF SHIP$ = "U.S.S. ENTERPRISE" THEN
            ENERGY = 20000 + ENERGY
            TORPEDOES = 20 + TORPEDOES
            SHENERGY = 10000
        ELSE
            ENERGY = 10000 + ENERGY
            TORPEDOES = 10 + TORPEDOES
            SHENERGY = 5000
        END IF
        DOTRDATE: SDATE = SDATE + RND
        HEREWEARE = 0
        CALL MAKEDISPLAY
    END IF
END IF
END SUB
